// BIOD_LiteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BIOD_Lite.h"
#include "BIOD_LiteDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//============== Parallel port ====================
#include "pt_ioctl.h"

#define DEFAULT_LPT_PORT_NAME	"LPT1"
#define DEFAULT_LPT_PORT_RW_ADDR	0x378
#define DEFAULT_LPT_PORT_READ_ADDR	(DEFAULT_LPT_PORT_RW_ADDR + 0x001)
#define LPT_DATA0_HIGH			0x01
#define LPT_DATA0_LOW			0x00
//#define VALVE_ON			LPT_DATA0_HIGH
//#define VALVE_OFF			LPT_DATA0_LOW

#define TIMER_FOOT_SW_SCAN	1

//======== for detecting input from parallel port ==========
#define SCAN_PERIOD		20 //scan port every 40ms
#define WAIT_COUNT_STADY_STATE	3
#define SWITCH_PUSHED		0
#define SWITCH_UNPUSHED		1
#define SCAN_COUNT_PUSHED 		3
#define SCAN_STATE0	0
#define SCAN_STATE1	1
#define SCAN_STATE2	2
#define SCAN_STATE3	3

//=================================================

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBIOD_LiteDlg dialog

CBIOD_LiteDlg::CBIOD_LiteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBIOD_LiteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBIOD_LiteDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBIOD_LiteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBIOD_LiteDlg)
	DDX_Control(pDX, IDC_LIST_ACTS_DEBUG, m_cListActSDebug);
	DDX_Control(pDX, IDC_STATIC_NEW_IMAGE, m_cNewImage);
	DDX_Control(pDX, IDC_LIST_PRINT_DEBUG, m_cListPrintDebug);
	DDX_Control(pDX, IDC_STATIC_PREVIEW, m_cPreview);
	DDX_Control(pDX, IDC_COMBO_VALVE_ACTION, m_cComboValveAction);
	DDX_Control(pDX, IDC_COMBO_UV_DEVICE, m_cComboUVDevice);	
	DDX_Control(pDX, IDC_LIST_ACTION, m_cListAction);
	DDX_Control(pDX, IDC_DDC1100CTRLCTRL, m_cDC1100);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBIOD_LiteDlg, CDialog)
	//{{AFX_MSG_MAP(CBIOD_LiteDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_UV_COMPORT, OnButtonUVComport)
	ON_BN_CLICKED(IDC_BUTTON_UV_CONTROL, OnButtonUVControl)
	ON_BN_CLICKED(IDC_BUTTON_UV_LAMP_ON, OnButtonUVLampOn)
	ON_BN_CLICKED(IDC_BUTTON_UV_SHUTTER_AUTO, OnButtonUVShutterAuto)
	ON_BN_CLICKED(IDC_BUTTON_UV_SHUTTER_MANUAL, OnButtonUVShutterManual)
	ON_BN_CLICKED(IDC_BUTTON_UV_SHUTTERTIME_READ, OnButtonUVShuttertimeRead)
	ON_BN_CLICKED(IDC_BUTTON_UV_SHUTTERTIME_SET, OnButtonUVShuttertimeSet)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_UV_INTENSITY, OnDeltaposSpinUVIntensity)
	ON_CBN_SELCHANGE(IDC_COMBO_UV_DEVICE, OnSelchangeComboUVDevice)
	ON_BN_CLICKED(IDC_BUTTON_VALVE00, OnButtonValve00)
	ON_BN_CLICKED(IDC_BUTTON_VALVE01, OnButtonValve01)
	ON_BN_CLICKED(IDC_BUTTON_VALVE02, OnButtonValve02)
	ON_BN_CLICKED(IDC_BUTTON_VALVE03, OnButtonValve03)
	ON_BN_CLICKED(IDC_BUTTON_VALVE04, OnButtonValve04)
	ON_BN_CLICKED(IDC_BUTTON_VALVE05, OnButtonValve05)
	ON_BN_CLICKED(IDC_BUTTON_VALVE06, OnButtonValve06)
	ON_BN_CLICKED(IDC_BUTTON_VALVE07, OnButtonValve07)
	ON_BN_CLICKED(IDC_BUTTON_VALVE10, OnButtonValve10)
	ON_BN_CLICKED(IDC_BUTTON_VALVE11, OnButtonValve11)
	ON_BN_CLICKED(IDC_BUTTON_VALVE12, OnButtonValve12)
	ON_BN_CLICKED(IDC_BUTTON_VALVE13, OnButtonValve13)
	ON_BN_CLICKED(IDC_BUTTON_VALVE14, OnButtonValve14)
	ON_BN_CLICKED(IDC_BUTTON_VALVE15, OnButtonValve15)
	ON_BN_CLICKED(IDC_BUTTON_VALVE16, OnButtonValve16)
	ON_BN_CLICKED(IDC_BUTTON_VALVE17, OnButtonValve17)
	ON_BN_CLICKED(IDC_BUTTON_VALVE20, OnButtonValve20)
	ON_BN_CLICKED(IDC_BUTTON_VALVE21, OnButtonValve21)
	ON_BN_CLICKED(IDC_BUTTON_VALVE22, OnButtonValve22)
	ON_BN_CLICKED(IDC_BUTTON_VALVE23, OnButtonValve23)
	ON_BN_CLICKED(IDC_BUTTON_VALVE24, OnButtonValve24)
	ON_BN_CLICKED(IDC_BUTTON_VALVE25, OnButtonValve25)
	ON_BN_CLICKED(IDC_BUTTON_VALVE26, OnButtonValve26)
	ON_BN_CLICKED(IDC_BUTTON_VALVE27, OnButtonValve27)
	ON_BN_CLICKED(IDC_BUTTON_VALVE30, OnButtonValve30)
	ON_BN_CLICKED(IDC_BUTTON_VALVE31, OnButtonValve31)
	ON_BN_CLICKED(IDC_BUTTON_VALVE32, OnButtonValve32)
	ON_BN_CLICKED(IDC_BUTTON_VALVE33, OnButtonValve33)
	ON_BN_CLICKED(IDC_BUTTON_VALVE34, OnButtonValve34)
	ON_BN_CLICKED(IDC_BUTTON_VALVE35, OnButtonValve35)
	ON_BN_CLICKED(IDC_BUTTON_VALVE36, OnButtonValve36)
	ON_BN_CLICKED(IDC_BUTTON_VALVE37, OnButtonValve37)
	ON_CBN_SELCHANGE(IDC_COMBO_VALVE_ACTION, OnSelchangeComboValveAction)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ACTION_REGIST, OnButtonValveActionRegist)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ACT1, OnButtonValveAct1)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ACT2, OnButtonValveAct2)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ACT3, OnButtonValveAct3)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ACT4, OnButtonValveAct4)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ACT5, OnButtonValveAct5)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ACT6, OnButtonValveAct6)
	ON_BN_CLICKED(IDC_BUTTON_NIDAQ_RUN, OnButtonNidaqRun)
	ON_BN_CLICKED(IDC_BUTTON_PRESSURE_COMPORT, OnButtonPressureComport)
	ON_BN_CLICKED(IDC_BUTTON_PRESSURE_STATUS, OnButtonPressureStatus)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_PRESS_VAR_STEP, OnDeltaposSpinPressVarStep)
	ON_BN_CLICKED(IDC_BUTTON_PRESS_ADD, OnButtonPressAdd)
	ON_BN_CLICKED(IDC_BUTTON_LOG_LOAD, OnButtonLogLoad)
	ON_BN_CLICKED(IDC_BUTTON_LOG_SAVE, OnButtonLogSave)
	ON_BN_CLICKED(IDC_BUTTON_LIST_UP, OnButtonListUp)
	ON_BN_CLICKED(IDC_BUTTON_LIST_DOWN, OnButtonListDown)
	ON_BN_CLICKED(IDC_BUTTON_LIST_DEL, OnButtonListDel)
	ON_BN_CLICKED(IDC_BUTTON_LIST_CLEAR, OnButtonListClear)
	ON_BN_CLICKED(IDC_BUTTON_MASK_ADD, OnButtonMaskAdd)
	ON_BN_CLICKED(IDC_BUTTON_ACTION_RUN, OnButtonActionRun)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_FOOT_SW, OnCheckFootSw)
	ON_BN_CLICKED(IDC_BUTTON_UV_ADD_ON, OnButtonUVAddOn)
	ON_BN_CLICKED(IDC_BUTTON_UV_ADD_OFF, OnButtonUVAddOff)
	ON_BN_CLICKED(IDC_BUTTON_VALVE_ADD, OnButtonValveAdd)
	ON_BN_CLICKED(IDC_BUTTON_PRESSURE_SET, OnButtonPressureSet)
	ON_BN_CLICKED(IDC_BUTTON_MASK_MIRROR, OnButtonMaskMirror)
	ON_BN_CLICKED(IDC_BUTTON_MASK_CENTRALIZE, OnButtonMaskCentralize)
	ON_BN_CLICKED(IDC_BUTTON_MASK_MOVE, OnButtonMaskMove)
	ON_BN_CLICKED(IDC_BUTTON_MASK_REPLACE, OnButtonMaskReplace)
	ON_BN_CLICKED(IDC_BUTTON_MASK_ROTATE_ARBIT, OnButtonMaskRotateArbit)
	ON_BN_CLICKED(IDC_BUTTON_MASK_ROTATE_CCW, OnButtonMaskRotateCcw)
	ON_BN_CLICKED(IDC_BUTTON_MASK_ROTATE_CW, OnButtonMaskRotateCw)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_PORT0, OnButtonPort0)
	ON_BN_CLICKED(IDC_BUTTON_PORT1, OnButtonPort1)
	ON_BN_CLICKED(IDC_BUTTON_PORT2, OnButtonPort2)
	ON_BN_CLICKED(IDC_BUTTON_PORT3, OnButtonPort3)
	ON_BN_CLICKED(IDC_BUTTON_TIME_ALLAPPLY, OnButtonTimeAllapply)
	ON_NOTIFY(NM_KILLFOCUS, IDC_LIST_ACTION, OnKillfocusListAction)
	ON_BN_CLICKED(IDC_BUTTON_MASK_RELOAD, OnButtonMaskReload)
	ON_BN_CLICKED(IDC_BUTTON_MASK_SAVE, OnButtonMaskSave)
	ON_BN_CLICKED(IDC_BUTTON_TEST1, OnButtonTest1)
	ON_BN_CLICKED(IDC_BUTTON_APPLY_ALL, OnButtonApplyAll)
	ON_BN_CLICKED(IDC_BUTTON_ACTS_APPLY, OnButtonActsApply)
	ON_BN_CLICKED(IDC_BUTTON_ACTS_CLEAR, OnButtonActsClear)
	ON_BN_CLICKED(IDC_BUTTON_ACTSDEBUGLIST_CLEAR, OnButtonActsdebuglistClear)
	//}}AFX_MSG_MAP

//-------------------------------------------------------------
// ON_MESSAGE(WM_COMM_NOTIFY, OnCommNotify)
// : Call back Message_Map of Com Port
//-------------------------------------------------------------
	ON_MESSAGE(WM_COMM_NOTIFY, OnCommNotify)

//-------------------------------------------------------------
// ON_MESSAGE(WM_NOTIFY_EDIT_MASK, OnNotifyReportListCtrl)
// : Report List select  ڵ ȣǴ Message_Map 
//-------------------------------------------------------------
	ON_MESSAGE(WM_ITEM_SELECTED, OnNotifyReportListCtrl)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBIOD_LiteDlg message handlers

BOOL CBIOD_LiteDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here	

	// Init extra variables
	InitExtra();

	// Init List Ctrl
	InitListCtrl();


	//==== INIT Parallel ======
	InitParallel();

	//==== INIT DMD Manager ======
	InitDMDManager();

	//==== INIT COM PORT ======
	InitCOMPort();

	//==== INIT UV Source =====
	InitUVControl();

	//==== INIT Press Control ======
	InitPressControl();

	//==== INIT Valve Control ======
	InitValveControl();	


	//==== INIT ActionManager(including DMD) ===========
//	InitActionManager();	


	return TRUE;  // return TRUE  unless you set the focus to a control
}

	
void CBIOD_LiteDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(m_pPreviewImage)
	{
		delete m_pPreviewImage;
	}

	if(m_pNewImage)
	{
		delete m_pNewImage;
	}

	if(m_pAllblackImage)
	{
		delete m_pAllblackImage;
	}

	CDialog::OnClose();
}

//================================================================

void CBIOD_LiteDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBIOD_LiteDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

//----------------------------------------------
//	if(m_pPreviewImage != NULL)
	if( m_bLoadPreviewImage == TRUE )
	{
	//	m_pPreviewDC = ((CWnd*)GetDlgItem(IDC_STATIC_PREVIEW))->GetWindowDC();	
		m_pPreviewImage->Draw(m_pPreviewDC->GetSafeHdc(), CRect(0, 0, m_iPreviewWidth, m_iPreviewHeight));
	//	ReleaseDC(m_pPreviewDC);
	}

	if( m_bLoadNewImage == TRUE )
	{
	//	m_pNewImageDC = ((CWnd*)GetDlgItem(IDC_STATIC_NEW_IMAGE))->GetWindowDC();	
		m_pNewImage->Draw(m_pNewImageDC->GetSafeHdc(), CRect(0, 0, m_iNewImageWidth, m_iNewImageHeight));
	//	ReleaseDC(m_pNewImageDC);
	}
//----------------------------------------------
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBIOD_LiteDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//================================================================
void CBIOD_LiteDlg::GetCurPath()
{
	CString strPath;
	int i;

	strPath = __argv[0];
	i = strPath.ReverseFind(0x5c);	//find '\'
	m_strCurrentPath = strPath.Left(i+1);
}

void CBIOD_LiteDlg::GetPath(CString strOrigin, CString &strPath)
{
	int i = strOrigin.ReverseFind(0x5c);	//find '\'
	strPath = strOrigin.Left(i+1);	
}

void CBIOD_LiteDlg::GetFileName(CString strOrigin, CString &strFile)
{
	int i = strOrigin.ReverseFind(0x5c);	//find '\'
	strFile = strOrigin.Right( strOrigin.GetLength() - i -1 );
}

BOOL CBIOD_LiteDlg::IncludePath(CString strPathFile)
{
	int i = strPathFile.ReverseFind(0x5c);	//find '\'
	if( i > 0 )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

BOOL CBIOD_LiteDlg::CheckAvailableFile(CString strFile)
{
	CFile File;
	CFileException e;
	int i;
	CString strTemp;

	if( !File.Open(strFile, CFile::modeRead|CFile::typeBinary, &e ) )
	{
		strTemp = "No File: ";
		i = strFile.ReverseFind(0x5c);	//find '\'		
		strTemp += strFile.Right(strFile.GetLength()-(i+1));			
		AfxMessageBox(strTemp);
		return FALSE;
	}
	File.Close();
	return TRUE;
}

BOOL CBIOD_LiteDlg::CheckAvailableFile(char *chFile)
{
	CString strTemp;
	strTemp.Format("%s", chFile);
	return CheckAvailableFile(strTemp);
}


BOOL CBIOD_LiteDlg::IsNumber(CString str)
{
	BOOL bNumber = TRUE;
	int i, len;
	len = str.GetLength();

	for(i=0;i<len;i++)
	{
		if( (str.GetAt(i) < 48) || (str.GetAt(i) > 57) )
		{
			bNumber = FALSE;
			break;
		}
	}
	
	return bNumber;
}

//================================================================

void CBIOD_LiteDlg::InitExtra()
{
	m_iNextTimerPeriod = 1000;
	m_bStartAction = FALSE;
	m_iTimerCount = 0;
	m_iCurrentIndex = 0;

	m_iSelectedItem = -1;
	m_iSelectedSubItem = -1; 

	m_iRunCycle = 1;

	SetDlgItemText(IDC_EDIT_RUN_CYCLE, "1");
	SetDlgItemText(IDC_EDIT_TIME_ALLAPPLY, "100");
	SetDlgItemText(IDC_EDIT_PRINT_CYCLE, "0/1");
	SetDlgItemText(IDC_EDIT_PROGRESS, "READY");

	GetCurPath();

	m_strLogFilePath = m_strCurrentPath;

//	m_cPreview.GetWindowRect(m_RectPreview);
	m_cPreview.GetClientRect(m_RectPreview);
	m_iPreviewWidth = m_RectPreview.Width();
	m_iPreviewHeight = m_RectPreview.Height();
	m_pPreviewDC = ((CWnd*)GetDlgItem(IDC_STATIC_PREVIEW))->GetWindowDC();		
	m_bLoadPreviewImage = FALSE;
	m_pPreviewImage = new CxImage;

//	m_cNewImage.GetWindowRect(m_RectNewImage);
	m_cNewImage.GetClientRect(m_RectNewImage);
	m_iNewImageWidth = m_RectNewImage.Width();
	m_iNewImageHeight = m_RectNewImage.Height();
	m_pNewImageDC = ((CWnd*)GetDlgItem(IDC_STATIC_NEW_IMAGE))->GetWindowDC();		
	m_bLoadNewImage = FALSE;
	m_pNewImage = new CxImage;
	m_iNewImageIndex = -1;

	m_pAllblackImage = new CxImage;
	m_bLoadAllblackImage = FALSE;
	//------------------------------------------------
	SetDlgItemText(IDC_EDIT_MASK_ROTATE_DEGREE, "0");
	SetDlgItemText(IDC_EDIT_MASK_MOVE_UP, "0");
	SetDlgItemText(IDC_EDIT_MASK_MOVE_DOWN, "0");
	SetDlgItemText(IDC_EDIT_MASK_MOVE_RIGHT, "0");
	SetDlgItemText(IDC_EDIT_MASK_MOVE_LEFT, "0");

	((CButton *)GetDlgItem(IDC_CHECK_CURED_FIGURE))->SetCheck(FALSE);
	//------------------------------------------------

	SetDlgItemText(IDC_STATIC_SAVE, "");


	m_bRunbyActionScript = FALSE;

	m_strActS = "";
	SetDlgItemText(IDC_EDIT_ACTION_SCRIPT, "");

	m_ActSctriptCmd.iNumSentences = 0;
	m_ActSctriptCmd.iCurSentence = 0;
	//========= for debugging of Action Script===================
	m_strActS += "begin;";
	m_strActS += 13;m_strActS += 10;
	m_strActS += "run 1 to 4 for 3;";
	m_strActS += 13;m_strActS += 10;
	m_strActS += "run 8 to 10 for 2;";
	m_strActS += 13;m_strActS += 10;
	m_strActS += "run 13 for 3;";
	m_strActS += 13;m_strActS += 10;
	m_strActS += "end;";
	m_strActS += 13;m_strActS += 10;

	SetDlgItemText(IDC_EDIT_ACTION_SCRIPT, m_strActS);

	m_cListActSDebug.ResetContent();
	//===========================================================

}


void CBIOD_LiteDlg::InitListCtrl()
{
	CRect rect;
	m_cListAction.GetClientRect(&rect);
	int width0 = 50;
	int width1 = 70;
	int width2 = 270;
	int width3 = rect.Width() - width0 - width1 - width2;
	int width4 = 10;

	CString str;
	str.Format("NO, %d, COLUMN_TEXT_ALIGN_RIGHT;ACTION, %d, COLUMN_TEXT_ALIGN_CENTER;NAME, %d, COLUMN_TEXT_ALIGN_CENTER;TIME, %d, COLUMN_TEXT_ALIGN_CENTER;D, %d, COLUMN_TEXT_ALIGN_CENTER", width0, width1, width2, width3, width4);

	m_cListAction.SetColumnHeader(str);
	m_cListAction.SetGridLines(TRUE);
	m_cListAction.SetCheckboxeStyle(RC_CHKBOX_NORMAL);
	m_cListAction.SetEditable(TRUE);	
}


LRESULT CBIOD_LiteDlg::OnNotifyReportListCtrl(WPARAM wParam, LPARAM lParam)
{
	LVHITTESTINFO *hti = (LVHITTESTINFO *)wParam;
	m_iSelectedItem = hti->iItem;
	m_iSelectedSubItem = hti->iSubItem;
	CString strName;

	if( m_iSelectedItem >= 0 )
	{
		if( m_cListAction.GetItemText(m_iSelectedItem, ACTION_LIST_COLUMN_ACTION) == "MASK" )
		{
			PreviewMask(m_cListAction.GetItemText(m_iSelectedItem, ACTION_LIST_COLUMN_FULLNAME));
		}
	}
	

	return 1;
}


void CBIOD_LiteDlg::OnKillfocusListAction(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
//	m_iSelectedItem = -1;
//	m_iSelectedSubItem = -1;

	*pResult = 0;
}


void CBIOD_LiteDlg::OnButtonTimeAllapply() 
{
	// TODO: Add your control notification handler code here
	CString strTime;
	char *chTemp;
	int iAllTime;

	GetDlgItemText(IDC_EDIT_TIME_ALLAPPLY, strTime);
	if( IsNumber(strTime) == FALSE )
	{
		return;
	}

	chTemp = strTime.GetBuffer(strTime.GetLength());
	iAllTime = atoi(chTemp);
	strTime.ReleaseBuffer();

	if( iAllTime < 10 )
	{
		iAllTime = 10;
		strTime = "10";
	}

	int iCount = m_cListAction.GetItemCount();
	for(int i=0;i<iCount;i++)
	{
		m_cListAction.SetItemText(i, ACTION_LIST_COLUMN_TIME, strTime);
	}
}

void CBIOD_LiteDlg::OnButtonApplyAll() 
{
	// TODO: Add your control notification handler code here
	int iIndex, iListNum;
	BOOL bCheck;

	iListNum = m_cListAction.GetItemCount();

	if( iListNum < 1 )
	{
		return;
	}

	bCheck = m_cListAction.GetCheck(0);
	if( bCheck == TRUE )
	{
		bCheck = FALSE;
	}
	else
	{
		bCheck = TRUE;
	}

	for(iIndex = 0; iIndex < iListNum; iIndex++)
	{
		m_cListAction.SetCheck(iIndex, bCheck);
	}
}

void CBIOD_LiteDlg::SetMMTimer(int iEvent, int iTime)
{
	m_iTimerEvent = iEvent;
	m_nTimerID = ::timeSetEvent(iTime, DEFAULT_MMTIMER_RESOLUTION, 
									(LPTIMECALLBACK) MMTimerProcess,
									(DWORD) this, TIME_PERIODIC | TIME_CALLBACK_FUNCTION);
}


//======= Multimedia Timer: Callback Function ================================
void CALLBACK MMTimerProcess( UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	CBIOD_LiteDlg* pClass = (CBIOD_LiteDlg*) dwUser;
    //pClass ̿ ó
	if( pClass->m_bRunbyActionScript == TRUE )
	{
		pClass->TimerRunActionScript();
	}
	else
	{
		pClass->TimerRun();
	}
}

//============================================================================

void CBIOD_LiteDlg::TimerRun()
{	
	CString strTemp, strAction, strName;
	BOOL bCheck;	
	char *chTemp;

	while(1)
	{	
		if( (m_iCurrentIndex >= m_iTotalListNum) && (m_bStartAction == TRUE) )	// end!!
		{
			m_iActionRunCount++;
			if(m_iActionRunCount > m_iRunCycle)
			{
				m_bStart = FALSE;
				m_iActionRunCount = 0;

				::timeKillEvent(m_nTimerID);

				m_bStartAction = FALSE;
				m_iCurrentIndex = 0;

				m_iTimerCount = -1;
				GetDlgItem(IDC_BUTTON_ACTION_RUN)->SetWindowText("Action:Stop");			
				m_bStartAction = FALSE;
				return;
			}
			else
			{
				m_iCurrentIndex = 0;				
			}
		}
		else if( m_bStart == FALSE )	// at first start
		{	
			m_iActionRunCount++;
			m_iCurrentIndex = 0;
			m_bStart = TRUE;			
		}

		bCheck = m_cListAction.GetCheck(m_iCurrentIndex);
		if( bCheck == TRUE )
		{
			break;
		}
		else
		{
			m_iCurrentIndex++;
		}		
	}// while(1)

	//=======================================================================================			
	strAction = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_ACTION);
	strName = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_NAME);
	if( strAction == "MASK" )
	{	
		strTemp = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_FULLNAME);
		
		if( m_DMDManager.DisplayOnDMD(strTemp) == FALSE )
		{
			m_iNextTimerPeriod = 1000;
			return;
		}
	}
	else if( strAction == "UV" )
	{		
		m_UVControl.UVControl(strName);
	}
	else if( strAction == "VALVE" )
	{
		m_ValveControl.ValveControl(strName);
	}
	else if( strAction == "PRESS" )
	{
		m_PressControl.PressControl(strName);
	}		
	//=======================================================================================
	
	strTemp.Format("%d / %d", m_iActionRunCount, m_iRunCycle);
	SetDlgItemText(IDC_EDIT_PRINT_CYCLE, strTemp);

	strTemp.Format("%d : ", m_iCurrentIndex+1);
	strTemp += strName;
	SetDlgItemText(IDC_EDIT_PROGRESS, strTemp);	
	

	if( m_bStart == FALSE )		// first start
	{
		m_bStart = TRUE;
	}

	strTemp = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_TIME);
	chTemp = strTemp.GetBuffer(strTemp.GetLength());		
	m_iNextTimerPeriod = atoi(chTemp);

	if(m_iNextTimerPeriod < 10)
	{
		m_iNextTimerPeriod = 10;
		m_cListAction.SetItemText(m_iCurrentIndex, 1, _T("10"));;
	}
	strTemp.ReleaseBuffer();

	m_iCurrentIndex++;

	::timeKillEvent(m_nTimerID);
	if(m_bStartAction == TRUE)
	{
		SetMMTimer(0, m_iNextTimerPeriod);
	}	
}

//==========================================================================================

//============== COM PORT =================================
void CBIOD_LiteDlg::InitCOMPort()
{
	int iPort;
	//================= UV COM Port ================================
	m_UVComPortUI.Init();
	m_UVControl.SetComPortInfo(&m_UVComPortUI);	

	if(	(m_UVComPortUI.m_bComPortOpen = OpenCOMPort(&m_UVComPort, &m_UVComPortUI)) == TRUE )
	{
		GetDlgItem(IDC_BUTTON_UV_COMPORT)->SetWindowText(m_UVComPortUI.m_strComPort);
	}
	else
	{
		for(iPort = NUM_OF_COMPORT; iPort > 0; iPort--)
		{
			m_UVComPortUI.m_iComPort = iPort;
			if(	(m_UVComPortUI.m_bComPortOpen = OpenCOMPort(&m_UVComPort, &m_UVComPortUI)) == TRUE )
			{
				m_UVComPortUI.m_strComPort.Format("COM%d", m_UVComPortUI.m_iComPort);
				GetDlgItem(IDC_BUTTON_UV_COMPORT)->SetWindowText(m_UVComPortUI.m_strComPort);
				break;
			}
		}
		
		if( iPort <= 0 )
		{
			GetDlgItem(IDC_BUTTON_UV_COMPORT)->SetWindowText("FAIL");
		}
	}

	//================= Press COM Port ================================
	m_PressComPortUI.Init();
	m_PressControl.SetComPortInfo(&m_PressComPortUI);	

	if(	(m_PressComPortUI.m_bComPortOpen = OpenCOMPort(&m_PressComPort, &m_PressComPortUI)) == TRUE )
	{
		GetDlgItem(IDC_BUTTON_PRESSURE_COMPORT)->SetWindowText(m_PressComPortUI.m_strComPort);
	}
	else
	{
		for(iPort = NUM_OF_COMPORT; iPort > 0; iPort--)
		{
			m_PressComPortUI.m_iComPort = iPort;
			if(	(m_PressComPortUI.m_bComPortOpen = OpenCOMPort(&m_PressComPort, &m_PressComPortUI)) == TRUE )
			{
				m_PressComPortUI.m_strComPort.Format("COM%d", m_PressComPortUI.m_iComPort);
				GetDlgItem(IDC_BUTTON_PRESSURE_COMPORT)->SetWindowText(m_PressComPortUI.m_strComPort);
				break;
			}
		}
		
		if( iPort <= 0 )
		{
			GetDlgItem(IDC_BUTTON_PRESSURE_COMPORT)->SetWindowText("FAIL");
		}
		
	}
}

BOOL CBIOD_LiteDlg::OpenCOMPort(CgtComPort *pComPort, CComPortUI *pComPortUI)
{
	if( pComPort->openPort(pComPortUI->m_iComPort, this, pComPortUI->m_iBaudrate, 
												pComPortUI->m_iDatabit,
												pComPortUI->m_iParity,
												pComPortUI->m_iStopbit) == TRUE )
	{
		
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}


//-------------------------------------------------------------
// Callback function for Serial Data
//-------------------------------------------------------------
LRESULT CBIOD_LiteDlg::OnCommNotify(WPARAM wParam, LPARAM lParam)
{
	int iPort = lParam;

	if( m_UVComPortUI.m_bComPortOpen == TRUE )
	{
		if( iPort == m_UVComPortUI.m_iComPort )
		{
			m_UVControl.ReceiveData();
		}
	}

	if( m_PressComPortUI.m_bComPortOpen == TRUE )
	{
		if( iPort == m_PressComPortUI.m_iComPort )
		{
			m_PressControl.ReceiveData();
		}
	}

	return 1;
}


//================= UV Control ========================
void CBIOD_LiteDlg::InitUVControl()
{
	m_UVControl.Init(this, &m_UVComPort);
	SetDlgItemText(IDC_EDIT_UV_INTENSITY, "0");
	SetDlgItemText(IDC_EDIT_UV_SHUTTERTIME, "0");
}

void CBIOD_LiteDlg::OnSelchangeComboUVDevice() 
{
	// TODO: Add your control notification handler code here
	int iSel = m_cComboUVDevice.GetCurSel();
	GetDlgItem(IDC_STATIC_UV_STATUS)->SetFocus();
	m_UVControl.SetDevice(iSel);		
}



void CBIOD_LiteDlg::OnButtonUVComport() 
{
	// TODO: Add your control notification handler code here
	if( m_UVComPortUI.DoModal() == IDOK )
	{
		m_UVComPortUI.m_bComPortOpen = FALSE;
		if( m_UVComPort.isOpened() == TRUE )
		{
			m_UVComPort.closePort();
		}
		
		if( TRUE == m_UVComPort.openPort(m_UVComPortUI.m_iComPort, this, m_UVComPortUI.m_iBaudrate, 
												m_UVComPortUI.m_iDatabit,
												m_UVComPortUI.m_iParity,
												m_UVComPortUI.m_iStopbit) )
		{
			CString strTemp;
			strTemp.Format("%s", m_UVComPortUI.m_iComPort);
			m_UVComPortUI.m_strComPort = strTemp;
			GetDlgItem(IDC_BUTTON_UV_COMPORT)->SetWindowText(m_UVComPortUI.m_strComPort);
			return;
		}
		else
		{
			GetDlgItem(IDC_BUTTON_UV_COMPORT)->SetWindowText("COM FAIL!");
		}
	}
}

void CBIOD_LiteDlg::OnButtonUVControl() 
{
	// TODO: Add your control notification handler code here
	m_UVControl.ControlMode();
}

void CBIOD_LiteDlg::OnButtonUVLampOn() 
{
	// TODO: Add your control notification handler code here
	m_UVControl.LampControl();
}

void CBIOD_LiteDlg::OnButtonUVShuttertimeRead() 
{
	// TODO: Add your control notification handler code here
	m_UVControl.ShutterTimeRead();
}

void CBIOD_LiteDlg::OnButtonUVShuttertimeSet() 
{
	// TODO: Add your control notification handler code here
	m_UVControl.ShutterTimeSet();
}

void CBIOD_LiteDlg::OnButtonUVShutterAuto() 
{
	// TODO: Add your control notification handler code here
	m_UVControl.ShutterAuto();
}

void CBIOD_LiteDlg::OnButtonUVShutterManual() 
{
	// TODO: Add your control notification handler code here
	m_UVControl.ShutterManual();
}


void CBIOD_LiteDlg::OnDeltaposSpinUVIntensity(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	if(pNMUpDown->iDelta < 0) // Click Up button
    {
		m_UVControl.IntensityControl(TRUE);	//Up
    }
    else                    // Click Down button
    {
		m_UVControl.IntensityControl(FALSE);	//Down
    }
	*pResult = 0;
}


//============== Valve Control =======================

void CBIOD_LiteDlg::InitValveControl()
{
	m_idValveMatrix[0][0] = IDC_BUTTON_VALVE00;
	m_idValveMatrix[0][1] = IDC_BUTTON_VALVE01;
	m_idValveMatrix[0][2] = IDC_BUTTON_VALVE02;
	m_idValveMatrix[0][3] = IDC_BUTTON_VALVE03;
	m_idValveMatrix[0][4] = IDC_BUTTON_VALVE04;
	m_idValveMatrix[0][5] = IDC_BUTTON_VALVE05;
	m_idValveMatrix[0][6] = IDC_BUTTON_VALVE06;
	m_idValveMatrix[0][7] = IDC_BUTTON_VALVE07;

	m_idValveMatrix[1][0] = IDC_BUTTON_VALVE10;
	m_idValveMatrix[1][1] = IDC_BUTTON_VALVE11;
	m_idValveMatrix[1][2] = IDC_BUTTON_VALVE12;
	m_idValveMatrix[1][3] = IDC_BUTTON_VALVE13;
	m_idValveMatrix[1][4] = IDC_BUTTON_VALVE14;
	m_idValveMatrix[1][5] = IDC_BUTTON_VALVE15;
	m_idValveMatrix[1][6] = IDC_BUTTON_VALVE16;
	m_idValveMatrix[1][7] = IDC_BUTTON_VALVE17;

	m_idValveMatrix[2][0] = IDC_BUTTON_VALVE20;
	m_idValveMatrix[2][1] = IDC_BUTTON_VALVE21;
	m_idValveMatrix[2][2] = IDC_BUTTON_VALVE22;
	m_idValveMatrix[2][3] = IDC_BUTTON_VALVE23;
	m_idValveMatrix[2][4] = IDC_BUTTON_VALVE24;
	m_idValveMatrix[2][5] = IDC_BUTTON_VALVE25;
	m_idValveMatrix[2][6] = IDC_BUTTON_VALVE26;
	m_idValveMatrix[2][7] = IDC_BUTTON_VALVE27;

	m_idValveMatrix[3][0] = IDC_BUTTON_VALVE30;
	m_idValveMatrix[3][1] = IDC_BUTTON_VALVE31;
	m_idValveMatrix[3][2] = IDC_BUTTON_VALVE32;
	m_idValveMatrix[3][3] = IDC_BUTTON_VALVE33;
	m_idValveMatrix[3][4] = IDC_BUTTON_VALVE34;
	m_idValveMatrix[3][5] = IDC_BUTTON_VALVE35;
	m_idValveMatrix[3][6] = IDC_BUTTON_VALVE36;
	m_idValveMatrix[3][7] = IDC_BUTTON_VALVE37;

	m_ValveControl.Init(this);
}


void CBIOD_LiteDlg::OnButtonNidaqRun() 
{
	// TODO: Add your control notification handler code here
	CString strTemp;

	GetDlgItemText(IDC_EDIT_NIDAQ_DEVICE_ID, strTemp);
	m_ValveControl.NIDAQRun(strTemp);
}


void CBIOD_LiteDlg::OnButtonValve00() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 0);
}

void CBIOD_LiteDlg::OnButtonValve01() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 1);
}

void CBIOD_LiteDlg::OnButtonValve02() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 2);
}

void CBIOD_LiteDlg::OnButtonValve03() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 3);
}

void CBIOD_LiteDlg::OnButtonValve04() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 4);
}

void CBIOD_LiteDlg::OnButtonValve05() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 5);
}

void CBIOD_LiteDlg::OnButtonValve06() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 6);
}

void CBIOD_LiteDlg::OnButtonValve07() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0, 7);
}

void CBIOD_LiteDlg::OnButtonValve10() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 0);
}

void CBIOD_LiteDlg::OnButtonValve11() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 1);
}

void CBIOD_LiteDlg::OnButtonValve12() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 2);
}

void CBIOD_LiteDlg::OnButtonValve13() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 3);
}

void CBIOD_LiteDlg::OnButtonValve14() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 4);
}

void CBIOD_LiteDlg::OnButtonValve15() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 5);
}

void CBIOD_LiteDlg::OnButtonValve16() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 6);
}

void CBIOD_LiteDlg::OnButtonValve17() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1, 7);
}

void CBIOD_LiteDlg::OnButtonValve20() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 0);
}

void CBIOD_LiteDlg::OnButtonValve21() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 1);
}

void CBIOD_LiteDlg::OnButtonValve22() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 2);
}

void CBIOD_LiteDlg::OnButtonValve23() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 3);
}

void CBIOD_LiteDlg::OnButtonValve24() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 4);
}

void CBIOD_LiteDlg::OnButtonValve25() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 5);
}

void CBIOD_LiteDlg::OnButtonValve26() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 6);
}

void CBIOD_LiteDlg::OnButtonValve27() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2, 7);
}

void CBIOD_LiteDlg::OnButtonValve30() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 0);
}

void CBIOD_LiteDlg::OnButtonValve31() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 1);
}

void CBIOD_LiteDlg::OnButtonValve32() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 2);
}

void CBIOD_LiteDlg::OnButtonValve33() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 3);
}

void CBIOD_LiteDlg::OnButtonValve34() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 4);
}

void CBIOD_LiteDlg::OnButtonValve35() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 5);
}

void CBIOD_LiteDlg::OnButtonValve36() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 6);
}

void CBIOD_LiteDlg::OnButtonValve37() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3, 7);
}


void CBIOD_LiteDlg::OnButtonPort0() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(0);
}

void CBIOD_LiteDlg::OnButtonPort1() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(1);
}

void CBIOD_LiteDlg::OnButtonPort2() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(2);
}

void CBIOD_LiteDlg::OnButtonPort3() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.ValveControl(3);
}

void CBIOD_LiteDlg::OnSelchangeComboValveAction() 
{
	// TODO: Add your control notification handler code here	
	GetDlgItem(IDC_STATIC_UV_STATUS)->SetFocus();
	
}


void CBIOD_LiteDlg::OnButtonValveActionRegist() 
{
	// TODO: Add your control notification handler code here
	int iSel = m_cComboValveAction.GetCurSel();
	m_ValveControl.SetAction(iSel);
}

void CBIOD_LiteDlg::OnButtonValveAct1() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.RunAction(0);
}

void CBIOD_LiteDlg::OnButtonValveAct2() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.RunAction(1);
}

void CBIOD_LiteDlg::OnButtonValveAct3() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.RunAction(2);
}

void CBIOD_LiteDlg::OnButtonValveAct4() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.RunAction(3);
}

void CBIOD_LiteDlg::OnButtonValveAct5() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.RunAction(4);
}

void CBIOD_LiteDlg::OnButtonValveAct6() 
{
	// TODO: Add your control notification handler code here
	m_ValveControl.RunAction(5);
}

//============= Press control ===============================
void CBIOD_LiteDlg::InitPressControl()
{
	m_PressControl.Init(this, &m_PressComPort);
}

void CBIOD_LiteDlg::OnButtonPressureComport() 
{
	// TODO: Add your control notification handler code here
	if( m_PressComPortUI.DoModal() == IDOK )
	{
		m_PressComPortUI.m_bComPortOpen = FALSE;
		if( m_PressComPort.isOpened() == TRUE )
		{
			m_PressComPort.closePort();
		}
		
		if( TRUE == m_PressComPort.openPort(m_PressComPortUI.m_iComPort, this, m_PressComPortUI.m_iBaudrate, 
												m_PressComPortUI.m_iDatabit,
												m_PressComPortUI.m_iParity,
												m_PressComPortUI.m_iStopbit) )
		{
			CString strTemp;
			strTemp.Format("%s", m_PressComPortUI.m_iComPort);
			m_PressComPortUI.m_strComPort = strTemp;
			GetDlgItem(IDC_BUTTON_PRESSURE_COMPORT)->SetWindowText(m_PressComPortUI.m_strComPort);
			return;
		}
		else
		{
			GetDlgItem(IDC_BUTTON_PRESSURE_COMPORT)->SetWindowText("COM FAIL!");
		}
	}
}

void CBIOD_LiteDlg::OnButtonPressureStatus() 
{
	// TODO: Add your control notification handler code here
	m_PressControl.Status();
}


void CBIOD_LiteDlg::OnButtonPressureSet() 
{
	// TODO: Add your control notification handler code here
	m_PressControl.Set();
}


void CBIOD_LiteDlg::OnDeltaposSpinPressVarStep(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here

	if(pNMUpDown->iDelta < 0) // Click Up button
    {
		m_PressControl.PressControl(TRUE);	//Up
    }
    else                    // Click Down button
    {
		m_PressControl.PressControl(FALSE);	//Up
    }
	*pResult = 0;
}


//================= DMD Manager ====================================
void CBIOD_LiteDlg::InitDMDManager()
{
	m_DMDManager.Init(this);
}


//============ Parallel control =============================

void CBIOD_LiteDlg::InitParallel()
{
	m_bLPTOpen = FALSE;
	
	((CButton *)GetDlgItem(IDC_RADIO_FOOT_AUTO))->EnableWindow(FALSE);
	((CButton *)GetDlgItem(IDC_RADIO_FOOT_MANUAL))->EnableWindow(FALSE);
	((CButton *)GetDlgItem(IDC_RADIO_FOOT_LIST))->EnableWindow(FALSE);

	((CButton *)GetDlgItem(IDC_CHECK_FOOT_SW))->SetCheck(FALSE);
	((CButton *)GetDlgItem(IDC_RADIO_FOOT_AUTO))->SetCheck(TRUE);

	if( OpenPortTalk() >= 0 )
	{
		m_bLPTOpen = TRUE;
		m_strLPTPortAddr = DEFAULT_LPT_PORT_NAME;
		m_wdLPTRWAddr = DEFAULT_LPT_PORT_RW_ADDR;
		m_wdLPTReadAddr = DEFAULT_LPT_PORT_READ_ADDR;		
	}
	else
	{
		m_bLPTOpen = FALSE;
	}

	InitScanPort();
}

BOOL CBIOD_LiteDlg::LPTOut(WORD LPTAddr, BYTE data)
{
	if(m_bLPTOpen == FALSE)
	{
		return FALSE;
	}

	outportb(LPTAddr, data);

	return TRUE;
}

BOOL CBIOD_LiteDlg::LPTOut(BYTE data)
{
	if(m_bLPTOpen == FALSE)
	{
		return FALSE;
	}

	outportb(m_wdLPTRWAddr, data);

	return TRUE;
}

BYTE CBIOD_LiteDlg::LPTRead(WORD LPTAddr)
{
	if(m_bLPTOpen == FALSE)
	{
		return FALSE;
	}

	return inportb(LPTAddr);
}

BYTE CBIOD_LiteDlg::LPTRead()
{	
	if(m_bLPTOpen == FALSE)
	{
		return FALSE;
	}

	return inportb(m_wdLPTReadAddr);
}

//===============================================
void CBIOD_LiteDlg::InitScanPort()
{
	m_iWaitCount = 0;
	m_iSwitchState = SCAN_STATE0;
	m_iSwitchStatus = SWITCH_UNPUSHED;
	m_iSwitchCount = 0;
	m_iSwitchFlag = SWITCH_UNPUSHED;
	m_iSwitchAction = SWITCH_UNPUSHED;
}

void CBIOD_LiteDlg::ScanPort()
{
	m_iSwitchStatus = (int)LPTRead();
	m_iSwitchStatus = (m_iSwitchStatus & 0x40) >> 6;
	switch(m_iSwitchState)
	{
		case SCAN_STATE0:
			if( m_iSwitchStatus == SWITCH_PUSHED ) 
			{
				m_iSwitchState = SCAN_STATE1;
			}
			break;
		case SCAN_STATE1:
			if( m_iSwitchStatus == SWITCH_PUSHED ) 
			{
				m_iSwitchCount++;
				if( m_iSwitchCount > SCAN_COUNT_PUSHED )
				{
					m_iSwitchFlag = SWITCH_PUSHED;
					m_iSwitchAction = SWITCH_PUSHED;
					m_iSwitchState = SCAN_STATE2;
					m_iSwitchCount = 0;

					SwitchAction(SWITCH_PUSHED);
				}
			}
			else
			{
				m_iSwitchStatus = SCAN_STATE0;
			}
			break;
		case SCAN_STATE2:
			if( m_iSwitchStatus == SWITCH_UNPUSHED ) 
			{
				m_iSwitchState = SCAN_STATE3;
			}
			break;
		case SCAN_STATE3:
			if( m_iSwitchStatus == SWITCH_UNPUSHED ) 
			{
				m_iSwitchCount++;
				if( m_iSwitchCount > SCAN_COUNT_PUSHED )
				{
					m_iSwitchFlag = SWITCH_UNPUSHED;
					m_iSwitchState = SCAN_STATE0;
					m_iSwitchCount = 0;

					SwitchAction(SWITCH_UNPUSHED);
				}
			}
			else
			{
				m_iSwitchState = SCAN_STATE0;
			}
			break;
		default:
			m_iSwitchState = SCAN_STATE0;
			m_iSwitchStatus = SWITCH_UNPUSHED;
			m_iSwitchCount = 0;
			m_iSwitchFlag = SWITCH_UNPUSHED;
			break;
	} // end switch
}

void CBIOD_LiteDlg::SwitchAction(int iSwitchStatus)
{
	if( m_bStartAction == TRUE )
	{
		return;
	}

	if( ((CButton *)GetDlgItem(IDC_RADIO_FOOT_AUTO))->GetCheck() == TRUE )
	{
		if( m_iSwitchStatus == SWITCH_PUSHED )
		{
			OnButtonUVShutterAuto();
		}
	}
	else if( ((CButton *)GetDlgItem(IDC_RADIO_FOOT_MANUAL))->GetCheck() == TRUE )
	{
		OnButtonUVShutterManual();
	}
	else if( ((CButton *)GetDlgItem(IDC_RADIO_FOOT_LIST))->GetCheck() == TRUE )
	{
		OnButtonActionRun();
	}
}

void CBIOD_LiteDlg::OnCheckFootSw() 
{
	// TODO: Add your control notification handler code here
	BOOL bCheck = ((CButton *)GetDlgItem(IDC_CHECK_FOOT_SW))->GetCheck();
	((CButton *)GetDlgItem(IDC_RADIO_FOOT_AUTO))->EnableWindow(bCheck);
	((CButton *)GetDlgItem(IDC_RADIO_FOOT_MANUAL))->EnableWindow(bCheck);
	((CButton *)GetDlgItem(IDC_RADIO_FOOT_LIST))->EnableWindow(bCheck);

	if( bCheck == TRUE )
	{
		InitScanPort();
		SetTimer(TIMER_FOOT_SW_SCAN, SCAN_PERIOD, NULL);
	}
	else
	{
		KillTimer(TIMER_FOOT_SW_SCAN);
		LPTOut(0x00);
	}
}

void CBIOD_LiteDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent)
	{
	case TIMER_FOOT_SW_SCAN:
		ScanPort();
		break;
	default:
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

//===============================================

/*
//------------------------------------------------------
#define ACTION_LIST_COLUMN_NO		0
#define ACTION_LIST_COLUMN_ACTION	1
#define ACTION_LIST_COLUMN_NAME		2
#define ACTION_LIST_COLUMN_TIME		3
#define ACTION_LIST_COLUMN_FULLNAME	4
//------------------------------------------------------
*/
//================= ACTION CONTROL ====================================
void CBIOD_LiteDlg::OnButtonLogLoad() 
{
	//=============================================
	CString strFileName, strPathName;
	strFileName = "*.log";
	strPathName = m_strLogFilePath + strFileName;
	
	CFileDialog fDlg(TRUE, NULL, strPathName, OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST, 
					"LOG Files (*.log)", this);

	fDlg.m_ofn.lpstrTitle = _T("Load LOG File");

	if( fDlg.DoModal() != IDOK)
	{		
		return;
	}
	strPathName = fDlg.GetPathName();
	strFileName = fDlg.GetFileName();
	
	m_strLogFilePath = strPathName;
	//=============================================
	GetPath(strPathName, m_strLogFilePath);
	//=============================================
	CFile File;
	CFileException e;
		
	if( !File.Open(strPathName, CFile::modeRead|CFile::typeBinary, &e ) )
	{
		AfxMessageBox("Log  ϴ.");
		return;
	}

	int iFileSize;
	char *chFile;
	CString strLogFile;
	iFileSize = File.GetLength();

	chFile = new char[iFileSize+1];
	
	File.Read(chFile, iFileSize);
	chFile[iFileSize] = '\0';
	strLogFile.Format("%s", chFile);
	delete[] chFile;
	File.Close();	
	//=============================================
	
	chFile = strLogFile.GetBuffer(strLogFile.GetLength());
	char seps[] = "/\r\n";
	char *token;
	CString strTemp, strIndex, strAction, strFullName;
	BOOL bNumber = FALSE;
	int iIndex;
	
	
	token = strtok(chFile, seps);
	strTemp.Format("%s", token);
	strTemp.TrimLeft();
	strTemp.TrimRight();
	if( strTemp != LOG_FILE_INDICATOR_BIOD_LITE )
	{
		AfxMessageBox("Log file version mismatch to BIOD Lite!");
		return;
	}

	strAction = "";
	iIndex = 0;

	while(token != NULL )
	{
		token = strtok(NULL, seps);
		strTemp.Format("%s", token);		
		strTemp.TrimLeft();
		strTemp.TrimRight();
		if( strTemp.Find("null") >= 0 )
		{
			break;
		}
		
		if( (strTemp == "MASK") || (strTemp == "UV") || (strTemp == "VALVE") || (strTemp == "PRESS") )
		{			
			strIndex.Format("%d", iIndex+1);
			m_cListAction.InsertItem(iIndex, strIndex);
			strAction = strTemp;
			m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_ACTION, strAction);
			continue;
		}

		if( strAction == "MASK" )
		{
			if( IncludePath(strTemp) == TRUE )
			{
				strFullName = strTemp;
				GetFileName(strTemp, strFileName);
			}
			else
			{
				strFullName = m_strCurrentPath + strTemp;
			}
			
			m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_NAME, strFileName);
			m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_FULLNAME, strFullName);

			
			if( m_DMDManager.AddMask(strFullName) == TRUE )
			{

			}
			else
			{
				m_cListAction.DeleteItem(iIndex);
				ActionListNoReorder(iIndex-1);

				strTemp = "Error occurred while Mask file loading!";
				strTemp += 13;
				strTemp += 10;
				strTemp += strFullName;
				AfxMessageBox(strTemp);
			}

			strAction = "";
		}		
		else if(strTemp.GetLength() == 1 )
		{
			if( strTemp == "O" )
			{
				m_cListAction.SetCheck(iIndex, TRUE);
			}
			else
			{
				m_cListAction.SetCheck(iIndex, FALSE);
			}			

			iIndex++;
		}		
		else
		{			
			if( IsNumber(strTemp) == TRUE )
			{
				m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_TIME, strTemp);
			}
			else
			{
				if( (strAction == "UV") || (strAction == "VALVE") || (strAction == "PRESS") )
				{
					m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_NAME, strTemp);
				}
			}
		}
	}
	strLogFile.ReleaseBuffer();	
}

void CBIOD_LiteDlg::OnButtonLogSave() 
{
	// TODO: Add your control notification handler code here
	//=============================================
	int iListCount = m_cListAction.GetItemCount();

	if( iListCount < 1 )
	{
		return;
	}

	//=============================================
	int i;
	CString strPathName;
	CString strFileName;
	
	CString strTemp;

	strTemp = m_strLogFilePath + "*.log";
	
	CFileDialog fDlg(TRUE, "*.log", strTemp, OFN_OVERWRITEPROMPT | OFN_LONGNAMES, 
							"LOG Files (*.log)|All Files (*.*) |*.*||", this);

	fDlg.m_ofn.lpstrTitle = _T("Save LOG File");

	if( fDlg.DoModal() != IDOK)
	{		
		return;
	}
	strPathName = fDlg.GetPathName();
	strFileName = fDlg.GetFileName();
//=============================================	
	GetPath(strPathName, m_strLogFilePath);
//=============================================
	CFile File;
	CFileException e;
		
	if( !File.Open(strPathName, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary, &e ) )
	{
		AfxMessageBox("Fail to save Log file.");
		return;
	}
//=============================================

//=============================================
	CString strWrite;

	strWrite = LOG_FILE_INDICATOR_BIOD_LITE;
	strWrite += "\r\n";
	for(i=0;i<iListCount;i++)
	{	
		strTemp = m_cListAction.GetItemText(i, ACTION_LIST_COLUMN_ACTION);	//Action
		strTemp += '/';
		strWrite += strTemp;
		
		if( strTemp == "MASK/" )
		{
			strTemp = m_cListAction.GetItemText(i, ACTION_LIST_COLUMN_FULLNAME);	//Full Name
		}
		else
		{
			strTemp = m_cListAction.GetItemText(i, ACTION_LIST_COLUMN_NAME);	//Name
		}
		strTemp += '/';
		strWrite += strTemp;

		strTemp = m_cListAction.GetItemText(i, ACTION_LIST_COLUMN_TIME);	//Time
		strTemp += '/';
		strWrite += strTemp;

		if( m_cListAction.GetCheck(i) == TRUE )
		{
			strTemp = "O";
		}
		else
		{
			strTemp = "X";
		}
		strTemp += "\r\n";
		strWrite += strTemp;
	}
		
	File.Write(strWrite, strWrite.GetLength());
	File.Close();	
//=============================================	
}

void CBIOD_LiteDlg::OnButtonListUp() 
{
	// TODO: Add your control notification handler code here
	int iIndex;

	iIndex = m_iSelectedItem;

	if( iIndex <= 0 )
	{
		return;
	}

	CString strTemp, strNo, strAction, strName, strTime, strFullName;
	BOOL bCheck;
	
	bCheck = m_cListAction.GetCheck(iIndex);	
	strAction = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_ACTION);
	strName = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_NAME);
	strTime = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_TIME);
	strFullName = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_FULLNAME);
	
	m_cListAction.DeleteItem(iIndex);
		
	strNo.Format("%d", iIndex);
	m_cListAction.InsertItem(iIndex-1, strNo);
	m_cListAction.SetItemText(iIndex-1, ACTION_LIST_COLUMN_ACTION, strAction);	
	m_cListAction.SetItemText(iIndex-1, ACTION_LIST_COLUMN_NAME, strName);
	m_cListAction.SetItemText(iIndex-1, ACTION_LIST_COLUMN_TIME, strTime);	
	m_cListAction.SetItemText(iIndex-1, ACTION_LIST_COLUMN_FULLNAME, strFullName);
	m_cListAction.SetCheck(iIndex-1, bCheck);	

	ActionListNoReorder(iIndex-1);
	m_iSelectedItem = iIndex-1;

}

void CBIOD_LiteDlg::OnButtonListDown() 
{
	// TODO: Add your control notification handler code here
	int iIndex = m_iSelectedItem;

	if( (iIndex < 0) || (iIndex == (m_cListAction.GetItemCount()-1)) )
	{
		return;
	}

	CString strTemp, strNo, strAction, strName, strTime, strFullName;
	BOOL bCheck;
	
	bCheck = m_cListAction.GetCheck(iIndex);	
	strAction = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_ACTION);
	strName = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_NAME);
	strTime = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_TIME);
	strFullName = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_FULLNAME);

	m_cListAction.DeleteItem(iIndex);

	strNo.Format("%d", iIndex+1);
	m_cListAction.InsertItem(iIndex+1, strNo);
	m_cListAction.SetItemText(iIndex+1, ACTION_LIST_COLUMN_ACTION, strAction);	
	m_cListAction.SetItemText(iIndex+1, ACTION_LIST_COLUMN_NAME, strName);
	m_cListAction.SetItemText(iIndex+1, ACTION_LIST_COLUMN_TIME, strTime);	
	m_cListAction.SetItemText(iIndex+1, ACTION_LIST_COLUMN_FULLNAME, strFullName);	
	m_cListAction.SetCheck(iIndex+1, bCheck);	


	ActionListNoReorder(iIndex);
	m_iSelectedItem = iIndex+1;

}

void CBIOD_LiteDlg::OnButtonListDel() 
{
	// TODO: Add your control notification handler code here
	int iIndex = m_iSelectedItem;

	if( iIndex < 0 )
	{
		return;
	}

	m_cListAction.DeleteItem(iIndex);
	ActionListNoReorder(iIndex-1);
	m_iSelectedItem = iIndex-1;
	if( m_iSelectedItem < 0 )
	{
		m_iSelectedItem = 0;
	}
}

void CBIOD_LiteDlg::OnButtonListClear() 
{
	// TODO: Add your control notification handler code here
	m_cListAction.DeleteAllItems();
	m_iSelectedItem = -1;
}

void CBIOD_LiteDlg::OnButtonUVAddOn() 
{
	// TODO: Add your control notification handler code here
	int iIndex = m_iSelectedItem;

	if( iIndex < 0 )
	{
		iIndex = m_cListAction.GetItemCount();
	}
	else
	{
		iIndex++;
	}

	CString strIndex;
	strIndex.Format("%d", iIndex+1);

	m_cListAction.InsertItem(iIndex, strIndex);
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_ACTION, "UV");
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_NAME, "ON");
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_TIME, "100");
	m_cListAction.SetCheck(iIndex, TRUE);

	ActionListNoReorder(iIndex);
}

void CBIOD_LiteDlg::OnButtonUVAddOff() 
{
	// TODO: Add your control notification handler code here
	int iIndex = m_iSelectedItem;

	if( iIndex < 0 )
	{
		iIndex = m_cListAction.GetItemCount();
	}
	else
	{
		iIndex++;
	}

	CString strIndex;
	strIndex.Format("%d", iIndex+1);

	m_cListAction.InsertItem(iIndex, strIndex);
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_ACTION, "UV");
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_NAME, "OFF");
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_TIME, "100");
	m_cListAction.SetCheck(iIndex, TRUE);

	ActionListNoReorder(iIndex);
}


void CBIOD_LiteDlg::OnButtonValveAdd() 
{
	// TODO: Add your control notification handler code here
	int iIndex = m_iSelectedItem;

	if( iIndex < 0 )
	{
		iIndex = m_cListAction.GetItemCount();
	}
	else
	{
		iIndex++;
	}

	CString strIndex, strValve;
	
	strIndex.Format("%d", iIndex+1);
	m_ValveControl.GetValveString(strValve);

	m_cListAction.InsertItem(iIndex, strIndex);
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_ACTION, "VALVE");
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_NAME, strValve);
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_TIME, "100");
	m_cListAction.SetCheck(iIndex, TRUE);

	ActionListNoReorder(iIndex);
}


void CBIOD_LiteDlg::OnButtonPressAdd() 
{
	// TODO: Add your control notification handler code here
	int iIndex = m_iSelectedItem;

	if( iIndex < 0 )
	{
		iIndex = m_cListAction.GetItemCount();
	}
	else
	{
		iIndex++;
	}

	CString strIndex, strPress;
	
	strIndex.Format("%d", iIndex+1);
	GetDlgItemText(IDC_EDIT_PRESS_OUTPUT, strPress);

	m_cListAction.InsertItem(iIndex, strIndex);
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_ACTION, "PRESS");
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_NAME, strPress);
	m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_TIME, "100");
	m_cListAction.SetCheck(iIndex, TRUE);

	ActionListNoReorder(iIndex);
}

void CBIOD_LiteDlg::ActionListNoReorder(int iCurIndex)
{
	int iIndex;
	CString strNo;

	for(iIndex = iCurIndex; iIndex<m_cListAction.GetItemCount(); iIndex++)
	{
		strNo.Format("%d", iIndex + 1);
		m_cListAction.SetItemText(iIndex, 0, strNo);
	}
}

void CBIOD_LiteDlg::OnButtonMaskAdd() 
{
	// TODO: Add your control notification handler code here
	//==========================================================
	CString strFileName, strPathName;
	strFileName = "*.bmp";
	strPathName = m_strCurrentPath + strFileName;
		
	CFileDialog fDlg(TRUE, NULL, strPathName, OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST, 
					"BMP Files (*.bmp) |*.bmp|All Files (*.*) |*.*||", this);

	fDlg.m_ofn.lpstrTitle = _T("Add Mask File");

	if( fDlg.DoModal() != IDOK)
	{		
		return;
	}
	strPathName = fDlg.GetPathName();
	strFileName = fDlg.GetFileName();	

	GetPath(strPathName, m_strCurrentPath);
	
	int iIndex;
	CString strIndex;

	if( m_DMDManager.AddMask(strPathName) == TRUE )
	{
		if( m_iSelectedItem < 0 )
		{
			iIndex = m_cListAction.GetItemCount();
		}
		else
		{
			iIndex = m_iSelectedItem;
		}

		strIndex.Format("%d", iIndex+1);

		m_cListAction.InsertItem(iIndex, strIndex);
		m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_ACTION, "MASK");
		m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_NAME, strFileName);
		m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_TIME, _T("100"));
		m_cListAction.SetItemText(iIndex, ACTION_LIST_COLUMN_FULLNAME, strPathName);
		m_cListAction.SetCheck(iIndex, TRUE);

		if( m_iSelectedItem >= 0 )
		{
			ActionListNoReorder(iIndex);
		}
	}
}


void CBIOD_LiteDlg::OnButtonMaskReload() 
{
	// TODO: Add your control notification handler code here
	int iIndex;
	CString strTemp;

	if( m_iSelectedItem < 0 )
	{
		return;
	}
	else
	{
		iIndex = m_iSelectedItem;
	}

	strTemp = m_cListAction.GetItemText(iIndex, ACTION_LIST_COLUMN_FULLNAME);		
	if( m_DMDManager.ReloadDMDBuffer(strTemp) == FALSE )
	{
	}

}


void CBIOD_LiteDlg::OnButtonActionRun() 
{
	// TODO: Add your control notification handler code here
	CString strTemp;
	char *chTemp;

	m_bRunbyActionScript = FALSE;

	if( m_bStartAction == FALSE )
	{	
		GetDlgItemText(IDC_EDIT_RUN_CYCLE, strTemp);
		chTemp = strTemp.GetBuffer(strTemp.GetLength());
		m_iRunCycle = atoi(chTemp);
		strTemp.ReleaseBuffer();

		m_iTotalListNum = m_cListAction.GetItemCount();
		m_iCurrentIndex = 0;
		m_iActionRunCount = 0;		
		m_bStart = FALSE;

		GetDlgItem(IDC_BUTTON_ACTION_RUN)->SetWindowText("Action:Start");		
		m_bStartAction = TRUE;	
		
		strTemp.Format("0/%d", m_iRunCycle);
		SetDlgItemText(IDC_EDIT_PRINT_CYCLE, strTemp);
		SetDlgItemText(IDC_EDIT_PROGRESS, " ");	
		
		SetMMTimer(0, 100);
	}
	else
	{
		::timeKillEvent(m_nTimerID);

		m_bStartAction = FALSE;
		m_bStart = FALSE;
		m_iActionRunCount = 0;		
		m_iTimerCount = -1;
		GetDlgItem(IDC_BUTTON_ACTION_RUN)->SetWindowText("Action:Stop");
		m_bStartAction = FALSE;
		m_iCurrentIndex = 0;
	}
}

//===================== CxImage ================================
CString CBIOD_LiteDlg::FindExtension(CString strName)
{
	int len = strName.GetLength();
	int i;
	for (i = len-1; i >= 0; i--)
	{
		if (strName.GetAt(i) == '.')
		{
			return strName.Mid(i+1);
		}
	}
	return CString("");
}

int CBIOD_LiteDlg::FindImageType(CString strExtension)
{
	int type = 0;
	if (strExtension == "bmp")
	{
		type = CXIMAGE_FORMAT_BMP;
	}
#if CXIMAGE_SUPPORT_JPG
	else if (strExtension=="jpg"||strExtension=="jpeg")
	{
		type = CXIMAGE_FORMAT_JPG;
	}
#endif
#if CXIMAGE_SUPPORT_GIF
	else if (strExtension == "gif")
	{
		type = CXIMAGE_FORMAT_GIF;
	}
#endif
	else
	{
		type = CXIMAGE_FORMAT_UNKNOWN;
	}

	return type;
}

void CBIOD_LiteDlg::PreviewMask(CString strFullName)
{	
/*	HBITMAP hBitMap;

	if( strFullName.Find(".bmp") < 0 )
	{
			
		hBitMap = (HBITMAP)LoadBitmap(NULL, MAKEINTRESOURCE(IDB_BITMAP1));
	}
	else
	{
		hBitMap = (HBITMAP)LoadImage(NULL, strFullName, IMAGE_BITMAP, m_iPreviewWidth, m_iPreviewHeight,
						LR_DEFAULTCOLOR | LR_LOADFROMFILE | LR_CREATEDIBSECTION);	
	}
	m_cPreview.SetBitmap(hBitMap);
	*/

	int iFileType = FindImageType(FindExtension(strFullName));
	if( iFileType > 0 )
	{
		m_pPreviewImage->Load(strFullName, iFileType);
		m_bLoadPreviewImage = TRUE;
		InvalidateRect(&m_RectPreview);
	}
}


void CBIOD_LiteDlg::LoadAllblackImage()
{
	HRSRC hrsc;
	int iFileType = CXIMAGE_FORMAT_BMP;

	if( m_bLoadAllblackImage == FALSE )
	{
		hrsc = FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_BITMAP_ALLBLACK), RT_BITMAP);
		m_pAllblackImage->LoadResource(hrsc, iFileType, NULL);
		m_bLoadAllblackImage = TRUE;
	}
}

void CBIOD_LiteDlg::LoadNewImage()
{
	CString strFullName;
	int iFileType;
	
	if( m_iNewImageIndex != m_iSelectedItem )
	{
		m_iNewImageIndex = m_iSelectedItem;
		strFullName = m_cListAction.GetItemText(m_iNewImageIndex, ACTION_LIST_COLUMN_FULLNAME);
		iFileType = FindImageType(FindExtension(strFullName));

		if( iFileType > 0 )
		{
			m_pNewImage->Load(strFullName, iFileType);
		}
	}

	if( m_bLoadNewImage == FALSE )
	{		
		m_bLoadNewImage = TRUE;		
	}

	SetDlgItemText(IDC_STATIC_SAVE, "S?");
}


void CBIOD_LiteDlg::OnButtonMaskMirror() 
{	
	LoadNewImage();

	m_pNewImage->Mirror();
	
	InvalidateRect(&m_RectNewImage);
}

void CBIOD_LiteDlg::OnButtonMaskRotateCcw() 
{
	// TODO: Add your control notification handler code here
	LoadNewImage();
//	LoadAllblackImage();

	m_pNewImage->RotateLeft();
//	m_pNewImage->Mix(*m_pAllblackImage, m_pAllblackImage->OpOr, 0, 0);
//	m_pNewImage->Crop(m_RectNewImage, NULL);
	
	InvalidateRect(&m_RectNewImage);
}

void CBIOD_LiteDlg::OnButtonMaskRotateCw() 
{
	// TODO: Add your control notification handler code here
	LoadNewImage();
	LoadAllblackImage();

	m_pNewImage->RotateRight();
	InvalidateRect(&m_RectNewImage);
}

void CBIOD_LiteDlg::OnButtonMaskRotateArbit() 
{
	// TODO: Add your control notification handler code here
	CString strDegree;
	int iDegree;
	char *chTemp;

	GetDlgItemText(IDC_EDIT_MASK_ROTATE_DEGREE, strDegree);
	if( IsNumber(strDegree) == FALSE )
	{
		return;
	}

	chTemp = strDegree.GetBuffer(strDegree.GetLength());
	iDegree = atoi(chTemp);
	strDegree.ReleaseBuffer();
	
	if( (iDegree < 0 ) || (iDegree > 360) )
	{
		return;
	}

	LoadNewImage();

	m_pNewImage->Rotate((float)iDegree);
	InvalidateRect(&m_RectNewImage);
}

void CBIOD_LiteDlg::OnButtonMaskReplace() 
{
	// TODO: Add your control notification handler code here	
	CString strFilename;

	if( m_DMDManager.AddMask(m_strRecentSavedNewImageFilename) == TRUE )
	{
		GetFileName(m_strRecentSavedNewImageFilename, strFilename);
		m_cListAction.SetItemText(m_iSelectedItem, ACTION_LIST_COLUMN_NAME, strFilename);
		m_cListAction.SetItemText(m_iSelectedItem, ACTION_LIST_COLUMN_FULLNAME, m_strRecentSavedNewImageFilename);
	}
	else
	{
	}
}

void CBIOD_LiteDlg::OnButtonMaskCentralize() 
{
	// TODO: Add your control notification handler code here
	
}

void CBIOD_LiteDlg::OnButtonMaskMove() 
{
	// TODO: Add your control notification handler code here
	
}


void CBIOD_LiteDlg::OnButtonMaskSave() 
{
	// TODO: Add your control notification handler code here
	if( m_bLoadNewImage == FALSE )
	{		
		return;
	}

	CString strTemp, strFullPath, strOriginFileName, strNewFilename;
	int iFileType;

	strTemp = m_cListAction.GetItemText(m_iSelectedItem, ACTION_LIST_COLUMN_FULLNAME);
	GetPath(strTemp, strFullPath);

	strOriginFileName = m_cListAction.GetItemText(m_iSelectedItem, ACTION_LIST_COLUMN_NAME);
	strNewFilename = "CFG_";
	strNewFilename += strOriginFileName;
	strFullPath += strNewFilename;
	
	iFileType = FindImageType(FindExtension(strFullPath));
	m_pNewImage->Save( (LPCTSTR)strFullPath, iFileType);
	
	SetDlgItemText(IDC_STATIC_SAVE, "S");

	m_strRecentSavedNewImageFilename = strFullPath;
}

void CBIOD_LiteDlg::PrintDebug(CString str)
{
	m_cListPrintDebug.AddString(str);
}


void CBIOD_LiteDlg::OnButtonTest1() 
{
	// TODO: Add your control notification handler code here
//	LoadAllblackImage();

//	m_pNewImage->Mix(*m_pPreviewImage, m_pPreviewImage->OpAnd, 0, 0);

	/*
	CString strFullName;
	
	MaskBuffer Buffer;
	Buffer.pByteArray = new CByteArray;
	Buffer.pByteArray->SetSize (1024 * 768 / 8);
	Buffer.pFrameBuffer = new COleVariant(*(Buffer.pByteArray));
	Buffer.chFullFileName = NULL;
	
	strFullName = m_cListAction.GetItemText(m_iSelectedItem, ACTION_LIST_COLUMN_FULLNAME);	
	
	Buffer.chFullFileName = strFullName.GetBuffer(strFullName.GetLength());

//#ifdef DMD_EXIST
	if( !m_cDC1100.LoadImageFileToBuffer(Buffer.chFullFileName, Buffer.pFrameBuffer, 0) )
	{
		return;
	}
//#endif

	strFullName.ReleaseBuffer();


//=============================================
	int i;
	CString strPathName;
	CString strTemp;

	strTemp = m_strLogFilePath + "*.bin";
	
	CFileDialog fDlg(TRUE, "*.bin", strTemp, OFN_OVERWRITEPROMPT | OFN_LONGNAMES, 
							"BIN Files (*.bin)|All Files (*.*) |*.*||", this);

	if( fDlg.DoModal() != IDOK)
	{		
		return;
	}
	strPathName = fDlg.GetPathName();

	CFile File;
	CFileException e;
		
	if( !File.Open(strPathName, CFile::modeCreate|CFile::modeWrite|CFile::typeBinary, &e ) )
	{
		AfxMessageBox("Fail to save Log file.");
		return;
	}
//=============================================

//=============================================
	CString strWrite;
	int iSize = Buffer.pByteArray->GetSize();

	CByteArray *pB = new CByteArray;

//	Buffer.pFrameBuffer->GetByteArrayFromVariantArray(pB);
	iSize = pB->GetSize();

	strWrite = "";
	
	for(i=0;i<iSize;i++)
	{	
		strTemp.Format("%x", pB->GetAt(i));
		strWrite += strTemp;
	}
		
	File.Write(strWrite, strWrite.GetLength());
	File.Close();	
//=============================================	

	delete Buffer.pByteArray;
	delete pB;

	*/	
}


//========== String manipulation ===============================
/*
void CReportCtrl::_StringSplit(const CString &str, CStringArray &arr, TCHAR chDelimitior)
{
	int nStart = 0, nEnd = 0;
	arr.RemoveAll();

	while (nEnd < str.GetLength())
	{
		// determine the paragraph ("xxx,xxx,xxx;")
		nEnd = str.Find(chDelimitior, nStart);
		if( nEnd == -1 )
		{
			// reached the end of string
			nEnd = str.GetLength();
		}

		CString s = str.Mid(nStart, nEnd - nStart);
		if (!s.IsEmpty())
			arr.Add(s);

		nStart = nEnd + 1;
	}
}

// using

CStringArray aLong, aShort;
	_StringSplit(strHeadings, aLong, _T(';'));
	for (int i = 0; i < aLong.GetSize(); i++)
	{
		_StringSplit(aLong[i], aShort, _T(','));
		if (aShort.GetSize() > 0)
		{
			const int WIDTH = aShort.GetSize() > 1 ? _ttoi(aShort[1]) : 100;
			int nFormat = aShort.GetSize() > 2 ? _ttoi(aShort[2]) : 0;

			if (nFormat == 1)
				nFormat = LVCFMT_CENTER;
			else if (nFormat == 2)
				nFormat = LVCFMT_RIGHT;
			else
				nFormat = LVCFMT_LEFT;

			bInserted |= (InsertColumn(GetColumnCount(), aShort[0], nFormat, WIDTH) >= 0);
		}
	}

*/

void CBIOD_LiteDlg::StringSplit(const CString &str, CStringArray &arr, TCHAR chDelimitior)
{
	int nStart = 0, nEnd = 0;
	arr.RemoveAll();

	while (nEnd < str.GetLength())
	{
		// determine the paragraph ("xxx,xxx,xxx;")
		nEnd = str.Find(chDelimitior, nStart);
		if( nEnd == -1 )
		{
			// reached the end of string
			nEnd = str.GetLength();
		}

		CString s = str.Mid(nStart, nEnd - nStart);
		if (!s.IsEmpty())
		{			
			if( s.Find(0x0d) >= 0 )
			{
				s.Remove(0x0d);
			}
			if( s.Find(0x0a) >= 0 )
			{
				s.Remove(0x0a);
			}
			arr.Add(s);
		}

		nStart = nEnd + 1;
	}
}


//========== ACTION SCRIPT =====================================
void CBIOD_LiteDlg::OnButtonActsdebuglistClear() 
{
	// TODO: Add your control notification handler code here
	m_cListActSDebug.ResetContent();
}

void CBIOD_LiteDlg::OnButtonActsClear() 
{
	// TODO: Add your control notification handler code here
	m_strActS = "";
	SetDlgItemText(IDC_EDIT_ACTION_SCRIPT, "");
}

BOOL CBIOD_LiteDlg::ActSGrammarCheck(CString strActs)
{
	int i, iSplit;
	CStringArray aCmdUnit;

	StringSplit(strActs, m_ActSctriptCmd.aSentence, _T(';'));
	m_ActSctriptCmd.iNumSentences = m_ActSctriptCmd.aSentence.GetSize();
	if( m_ActSctriptCmd.iNumSentences < 1 )
	{
		return FALSE;
	}

	/*
//////////////////////////////////////////////
	m_cListActSDebug.ResetContent();

	for(i = 0; i < m_ActSctriptCmd.iNumSentences; i++)
	{
		StringSplit(m_ActSctriptCmd.aSentence[i], aCmdUnit, _T(' '));		
		iSplit = aCmdUnit.GetSize();

		if( iSplit < 1 )
		{
			return FALSE;
		}
	
	//////////////////////////////////////////////
		{
		int j;
		CString strTemp;
		for(j=0;j<iSplit;j++)
		{
			strTemp += aCmdUnit[j];
			strTemp += "..";
		}
		m_cListActSDebug.AddString(strTemp);
		}
	//////////////////////////////////////////////
	}
//////////////////////////////////////////////
*/
	if( AnalyzeActScript() == FALSE )
	{
		return FALSE;
	}

	return TRUE;
}


BOOL CBIOD_LiteDlg::AnalyzeActScript()
{
	int iIndex, iSplit;
	CStringArray aCmdUnit;

	for(iIndex=0;iIndex<m_ActSctriptCmd.iNumSentences;iIndex++)
	{
		StringSplit(m_ActSctriptCmd.aSentence[iIndex], aCmdUnit, _T(' '));		
		iSplit = aCmdUnit.GetSize();

		switch (iSplit)
		{
		case 0:
			return FALSE;
			break;
		case 1:
			if( (aCmdUnit == "begin") || (aCmdUnit == "end") )
			{
				return TRUE;
			}
			break;
		case 2:
			break;
		case 3:
			break;
		case 4:
			break;
		default:
			break;
		}
	}

	return TRUE;
}


void CBIOD_LiteDlg::OnButtonActsApply() 
{
	// TODO: Add your control notification handler code here
	GetDlgItemText(IDC_EDIT_ACTION_SCRIPT, m_strActS);
	if( m_strActS == "" )
	{
		return;
	}

	if( ActSGrammarCheck(m_strActS) == FALSE )
	{
		return;
	}


	m_bRunbyActionScript = TRUE;

//===========================================================
	CString strTemp;
	char *chTemp;

	if( m_bStartAction == FALSE )
	{	
		GetDlgItemText(IDC_EDIT_RUN_CYCLE, strTemp);
		chTemp = strTemp.GetBuffer(strTemp.GetLength());
		m_iRunCycle = atoi(chTemp);
		strTemp.ReleaseBuffer();

		m_iTotalListNum = m_cListAction.GetItemCount();
		m_iCurrentIndex = 0;
		m_iActionRunCount = 0;		
		m_bStart = FALSE;

		GetDlgItem(IDC_BUTTON_ACTION_RUN)->SetWindowText("Action:Start");		
		m_bStartAction = TRUE;	
		
		strTemp.Format("0/%d", m_iRunCycle);
		SetDlgItemText(IDC_EDIT_PRINT_CYCLE, strTemp);
		SetDlgItemText(IDC_EDIT_PROGRESS, " ");	
		
		SetMMTimer(0, 100);
	}
	else
	{
		::timeKillEvent(m_nTimerID);

		m_bStartAction = FALSE;
		m_bStart = FALSE;
		m_iActionRunCount = 0;		
		m_iTimerCount = -1;
		GetDlgItem(IDC_BUTTON_ACTION_RUN)->SetWindowText("Action:Stop");
		m_bStartAction = FALSE;
		m_iCurrentIndex = 0;
	}

}



void CBIOD_LiteDlg::TimerRunActionScript()
{
	CString strTemp, strAction, strName;
//	BOOL bCheck;	
	char *chTemp;

	if( m_ActSctriptCmd.iCurSentence >= m_ActSctriptCmd.iNumSentences )
	{
		m_bStart = FALSE;
		m_iActionRunCount = 0;

		::timeKillEvent(m_nTimerID);

		m_bStartAction = FALSE;
		m_iCurrentIndex = 0;

		m_iTimerCount = -1;
		GetDlgItem(IDC_BUTTON_ACTION_RUN)->SetWindowText("Action:Stop");			
		m_bStartAction = FALSE;
		return;
	}

	//=======================================================================================			
	strAction = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_ACTION);
	strName = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_NAME);
	if( strAction == "MASK" )
	{	
		strTemp = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_FULLNAME);
		
		if( m_DMDManager.DisplayOnDMD(strTemp) == FALSE )
		{
			m_iNextTimerPeriod = 1000;
			return;
		}
	}
	else if( strAction == "UV" )
	{		
		m_UVControl.UVControl(strName);
	}
	else if( strAction == "VALVE" )
	{
		m_ValveControl.ValveControl(strName);
	}
	else if( strAction == "PRESS" )
	{
		m_PressControl.PressControl(strName);
	}		
	//=======================================================================================
	
	strTemp.Format("%d / %d", m_iActionRunCount, m_iRunCycle);
	SetDlgItemText(IDC_EDIT_PRINT_CYCLE, strTemp);

	strTemp.Format("%d : ", m_iCurrentIndex+1);
	strTemp += strName;
	SetDlgItemText(IDC_EDIT_PROGRESS, strTemp);	
	

	if( m_bStart == FALSE )		// first start
	{
		m_bStart = TRUE;
	}

	strTemp = m_cListAction.GetItemText(m_iCurrentIndex, ACTION_LIST_COLUMN_TIME);
	chTemp = strTemp.GetBuffer(strTemp.GetLength());		
	m_iNextTimerPeriod = atoi(chTemp);

	if(m_iNextTimerPeriod < 10)
	{
		m_iNextTimerPeriod = 10;
		m_cListAction.SetItemText(m_iCurrentIndex, 1, _T("10"));;
	}
	strTemp.ReleaseBuffer();

	m_ActSctriptCmd.iCurSentence++;

	::timeKillEvent(m_nTimerID);
	if(m_bStartAction == TRUE)
	{
		SetMMTimer(0, m_iNextTimerPeriod);
	}
}


