// BIOD_LiteDlg.h : header file
//
//{{AFX_INCLUDES()
#include "ddc1100ctrl.h"
//}}AFX_INCLUDES

#if !defined(AFX_BIOD_LITEDLG_H__F07CE490_8378_4412_8C45_5BA6DF2D9663__INCLUDED_)
#define AFX_BIOD_LITEDLG_H__F07CE490_8378_4412_8C45_5BA6DF2D9663__INCLUDED_

#include "ReportCtrl.h"
#include "ComPortUI.h"
#include "gtComPort.h"
#include "UVControl.h"
#include "ValveControl.h"
#include "PressControl.h"
#include "DMDManager.h"

//---------- Image processing ------------------------	
#include ".\include\ximage.h"
//----------------------------------------------------


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//=========== Multimedia TIMER ===========================
#include "MMSYSTEM.H"
#pragma comment( lib, "winmm.lib" )

static void CALLBACK MMTimerProcess( UINT uID,			//uTimerID
									UINT uMsg,			//dwUser : UserParam
									DWORD dwUser,		//Reserved
									DWORD dw1,			//Reserved
									DWORD dw2);			//Reserved 
#define DEFAULT_MMTIMER_RESOLUTION 5
#define WM_NOTIFY_MMTIMER	WM_USER+101

//------------------------------------------------------
#define PARENT_CLASS	CBIOD_LiteDlg
//------------------------------------------------------

//------------------------------------------------------
#define ACTION_LIST_COLUMN_NO		0
#define ACTION_LIST_COLUMN_ACTION	1
#define ACTION_LIST_COLUMN_NAME		2
#define ACTION_LIST_COLUMN_TIME		3
#define ACTION_LIST_COLUMN_FULLNAME	4
//------------------------------------------------------

#define LOG_FILE_INDICATOR_BIOD_LITE	"BIOD LITE"

#define NUM_OF_COMPORT	10
/////////////////////////////////////////////////////////////////////////////

typedef struct ActSctriptCmd
{
	int iNumSentences;
	int iCurSentence;
	int *iRunIndex;
	int iRunCycle;
	CStringArray aSentence;
} ActSctriptCmd;


/////////////////////////////////////////////////////////////////////////////
// CBIOD_LiteDlg dialog

class CBIOD_LiteDlg : public CDialog
{
// Construction
public:
	BOOL AnalyzeActScript(void);
	void TimerRunActionScript();
	BOOL m_bRunbyActionScript;
//---------- about Action Script ------------------------			
	ActSctriptCmd m_ActSctriptCmd;

	void StringSplit(const CString &str, CStringArray &arr, TCHAR chDelimitior);
	BOOL ActSGrammarCheck(CString strActs);
	CString m_strActS;
	
//---------- about Image processing ------------------------			
	void LoadAllblackImage(void);
	void LoadNewImage(void);
	int FindImageType(CString strExtension);
	CString FindExtension(CString strName);
	void PrintDebug(CString str);
	BOOL IsNumber(CString str);

//---------- Image processing ------------------------		
	CString m_strRecentSavedNewImageFilename;

	BOOL m_bLoadAllblackImage;
	CxImage *m_pAllblackImage;
	
	int m_iNewImageIndex;
	BOOL m_bLoadNewImage;
	CxImage *m_pNewImage;
	CDC *m_pNewImageDC;
	CRect m_RectNewImage;
	int m_iNewImageWidth;
	int m_iNewImageHeight;
	
	BOOL m_bLoadPreviewImage;
	CxImage *m_pPreviewImage;
	CDC *m_pPreviewDC;
	CRect m_RectPreview;
	int m_iPreviewWidth;
	int m_iPreviewHeight;
//----------------------------------------------------

	void PreviewMask(CString strFullName);
	BOOL OpenCOMPort(CgtComPort *pComPort, CComPortUI *pComPortUI);
	BOOL m_bStart;
	int m_iActionRunCount;
	int m_iRunCycle;
	void ActionListNoReorder(int iCurIndex);
//====================================
	void InitScanPort(void);
	void SwitchAction(int iSwitchStatus);
	void ScanPort(void);
	int m_iWaitCount;
	int m_iSwitchState;
	int m_iSwitchStatus;
	int m_iSwitchCount;
	int m_iSwitchFlag;
	int m_iSwitchAction;

	BYTE LPTRead(void);
	BYTE LPTRead(WORD LPTAddr);
	BOOL LPTOut(BYTE data);
	BOOL LPTOut(WORD LPTAddr, BYTE data);
	void InitParallel(void);
	CString m_strLPTPortAddr;
	WORD m_wdLPTRWAddr;
	WORD m_wdLPTReadAddr;
	BOOL m_bLPTOpen;
//====================================

	void InitDMDManager(void);
	CString m_strLogFilePath;
	void InitPressControl(void);
	int m_idValveMatrix[NUM_OF_VALVE_PORT][NUM_OF_VALVE_LINE];
	void InitValveControl(void);
	CString m_strCurrentPath;
	BOOL CheckAvailableFile(char *chFile);
	BOOL CheckAvailableFile(CString strFile);
	BOOL IncludePath(CString strPathFile);
	void GetFileName(CString strOrigin, CString &strFile);
	void GetPath(CString strOrigin, CString &strPath);
	void GetCurPath();
	BOOL m_bComPortOpen;
	void InitCOMPort();
	void InitUVControl();
	int m_iTotalListNum;
	int m_iCurrentIndex;
	void TimerRun(void);
	int m_iTimerCount;
	BOOL m_bStartAction;
	UINT m_nTimerID;
	int m_iTimerEvent;
	int m_iNextTimerPeriod;
	void SetMMTimer(int iEvent, int iTime);
	void InitExtra(void);
	void InitListCtrl(void);
	int m_iSelectedSubItem;
	int m_iSelectedItem;
	
	CBIOD_LiteDlg(CWnd* pParent = NULL);	// standard constructor

	CComPortUI m_UVComPortUI;
	CgtComPort m_UVComPort;		
	CUVControl m_UVControl;
	
	CComPortUI m_PressComPortUI;
	CgtComPort m_PressComPort;
	CPressControl m_PressControl;

	CValveControl m_ValveControl;
		
	CDMDManager m_DMDManager;

	CComPortUI m_ComPortUI;

// Dialog Data
	//{{AFX_DATA(CBIOD_LiteDlg)
	enum { IDD = IDD_BIOD_LITE_DIALOG };
	CListBox	m_cListActSDebug;
	CStatic	m_cNewImage;
	CListBox	m_cListPrintDebug;
	CStatic	m_cPreview;
	CComboBox	m_cComboValveAction;
	CComboBox	m_cComboUVDevice;
	CReportCtrl	m_cListAction;
	CDDC1100Ctrl	m_cDC1100;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBIOD_LiteDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBIOD_LiteDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonUVComport();
	afx_msg void OnButtonUVControl();
	afx_msg void OnButtonUVLampOn();
	afx_msg void OnButtonUVShutterAuto();
	afx_msg void OnButtonUVShutterManual();
	afx_msg void OnButtonUVShuttertimeRead();
	afx_msg void OnButtonUVShuttertimeSet();
	afx_msg void OnDeltaposSpinUVIntensity(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeComboUVDevice();
	afx_msg void OnButtonValve00();
	afx_msg void OnButtonValve01();
	afx_msg void OnButtonValve02();
	afx_msg void OnButtonValve03();
	afx_msg void OnButtonValve04();
	afx_msg void OnButtonValve05();
	afx_msg void OnButtonValve06();
	afx_msg void OnButtonValve07();
	afx_msg void OnButtonValve10();
	afx_msg void OnButtonValve11();
	afx_msg void OnButtonValve12();
	afx_msg void OnButtonValve13();
	afx_msg void OnButtonValve14();
	afx_msg void OnButtonValve15();
	afx_msg void OnButtonValve16();
	afx_msg void OnButtonValve17();
	afx_msg void OnButtonValve20();
	afx_msg void OnButtonValve21();
	afx_msg void OnButtonValve22();
	afx_msg void OnButtonValve23();
	afx_msg void OnButtonValve24();
	afx_msg void OnButtonValve25();
	afx_msg void OnButtonValve26();
	afx_msg void OnButtonValve27();
	afx_msg void OnButtonValve30();
	afx_msg void OnButtonValve31();
	afx_msg void OnButtonValve32();
	afx_msg void OnButtonValve33();
	afx_msg void OnButtonValve34();
	afx_msg void OnButtonValve35();
	afx_msg void OnButtonValve36();
	afx_msg void OnButtonValve37();
	afx_msg void OnSelchangeComboValveAction();
	afx_msg void OnButtonValveActionRegist();
	afx_msg void OnButtonValveAct1();
	afx_msg void OnButtonValveAct2();
	afx_msg void OnButtonValveAct3();
	afx_msg void OnButtonValveAct4();
	afx_msg void OnButtonValveAct5();
	afx_msg void OnButtonValveAct6();
	afx_msg void OnButtonNidaqRun();
	afx_msg void OnButtonPressureComport();
	afx_msg void OnButtonPressureStatus();
	afx_msg void OnDeltaposSpinPressVarStep(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonPressAdd();
	afx_msg void OnButtonLogLoad();
	afx_msg void OnButtonLogSave();
	afx_msg void OnButtonListUp();
	afx_msg void OnButtonListDown();
	afx_msg void OnButtonListDel();
	afx_msg void OnButtonListClear();
	afx_msg void OnButtonMaskAdd();
	afx_msg void OnButtonActionRun();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCheckFootSw();
	afx_msg void OnButtonUVAddOn();
	afx_msg void OnButtonUVAddOff();
	afx_msg void OnButtonValveAdd();
	afx_msg void OnButtonPressureSet();
	afx_msg void OnButtonMaskMirror();
	afx_msg void OnButtonMaskCentralize();
	afx_msg void OnButtonMaskMove();
	afx_msg void OnButtonMaskReplace();
	afx_msg void OnButtonMaskRotateArbit();
	afx_msg void OnButtonMaskRotateCcw();
	afx_msg void OnButtonMaskRotateCw();
	afx_msg void OnClose();
	afx_msg void OnButtonPort0();
	afx_msg void OnButtonPort1();
	afx_msg void OnButtonPort2();
	afx_msg void OnButtonPort3();
	afx_msg void OnButtonTimeAllapply();
	afx_msg void OnKillfocusListAction(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonMaskReload();
	afx_msg void OnButtonMaskSave();
	afx_msg void OnButtonTest1();
	afx_msg void OnButtonApplyAll();
	afx_msg void OnButtonActsApply();
	afx_msg void OnButtonActsClear();
	afx_msg void OnButtonActsdebuglistClear();
	//}}AFX_MSG

//-------------------------------------------------------------
// afx_msg LRESULT OnCommNotify(WPARAM, LPARAM)
// : Call back function when data is received via Com Port
//-------------------------------------------------------------
	afx_msg LRESULT OnCommNotify(WPARAM, LPARAM);

//-------------------------------------------------------------
// afx_msg LRESULT OnNotifyReportListCtrl(WPARAM, LPARAM);
// : Report List Ctrl 
//-------------------------------------------------------------
	afx_msg LRESULT OnNotifyReportListCtrl(WPARAM, LPARAM);


	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BIOD_LITEDLG_H__F07CE490_8378_4412_8C45_5BA6DF2D9663__INCLUDED_)
