// DMDManager.cpp : implementation file
//

#include "stdafx.h"
#include "BIOD_Lite.h"
#include "BIOD_LiteDlg.h"
#include "DMDManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CDMDManager

CDMDManager::CDMDManager()
{
}

CDMDManager::~CDMDManager()
{
/*	POSITION pos;
	MaskBuffer *pMaskBuffer;
	for(pos = m_BufferList.GetHeadPosition();pos != NULL; )
	{
		pMaskBuffer = (MaskBuffer *)m_BufferList.GetNext(pos);
		delete pMaskBuffer->pByteArray;
		delete pMaskBuffer->chFullFileName;
		delete pMaskBuffer;
	}
*/
	int i;
	for(i=0;i<MAX_NUM_OF_MASK_BUFFER;i++)
	{
		if( m_MaskBufferArray[i].pByteArray != NULL )
		{
			delete m_MaskBufferArray[i].pByteArray;
		}
		if( m_MaskBufferArray[i].chFullFileName != NULL )
		{
			delete m_MaskBufferArray[i].chFullFileName;
		}
	}
}


BEGIN_MESSAGE_MAP(CDMDManager, CWnd)
	//{{AFX_MSG_MAP(CDMDManager)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP

//-------------------------------------------------------------
// afx_msg LRESULT OnThreadMSG_LoadDMDEnd(WPARAM, LPARAM);
//-------------------------------------------------------------

END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDMDManager message handlers

void CDMDManager::Init(CWnd *pWnd)
{
	m_pParentWnd = pWnd;
	m_bConnected = FALSE;

	InitDMD();
		
	m_iMaskBufferIndex = 0;
	m_bFullMaskBuffer = FALSE;
	
	for(int i=0;i<MAX_NUM_OF_MASK_BUFFER;i++)
	{		
		m_MaskBufferArray[i].pByteArray = new CByteArray;
		m_MaskBufferArray[i].pByteArray->SetSize (1024 * 768 / 8);
		m_MaskBufferArray[i].pFrameBuffer = new COleVariant(*(m_MaskBufferArray[i].pByteArray));
		m_MaskBufferArray[i].chFullFileName = NULL;
	}
}

BOOL CDMDManager::InitDMD()
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;

#ifdef DMD_EXIST
	if( pWnd->m_cDC1100.GetDevice() == TRUE )
	{
		pWnd->m_cDC1100.EnableParallel(0);	// Set DC1100 to USB mode
		m_bConnected = TRUE;		
	}
	else
#endif
	{
		m_bConnected = FALSE;				
	}

#ifndef DMD_EXIST
	m_bConnected = TRUE;
#endif

	return m_bConnected;
}

void CDMDManager::GetPath(CString strOrigin, CString &strPath)
{
	int i = strOrigin.ReverseFind(0x5c);	//find '\'
	strPath = strOrigin.Left(i+1);	
}

void CDMDManager::GetFileName(CString strOrigin, CString &strFile)
{
	int i = strOrigin.ReverseFind(0x5c);	//find '\'
	strFile = strOrigin.Right( strOrigin.GetLength() - i -1 );
}

BOOL CDMDManager::CheckAvailableFile(CString strFile)
{
	CFile File;
	CFileException e;
	int i;
	CString strTemp;

	if( !File.Open(strFile, CFile::modeRead|CFile::typeBinary, &e ) )
	{
		strTemp = "No File: ";
		i = strFile.ReverseFind(0x5c);	//find '\'		
		strTemp += strFile.Right(strFile.GetLength()-(i+1));			
		AfxMessageBox(strTemp);
		return FALSE;
	}
	File.Close();
	return TRUE;
}

BOOL CDMDManager::CheckAvailableFile(char *chFile)
{
	CString strTemp;
	strTemp.Format("%s", chFile);
	return CheckAvailableFile(strTemp);
}

BOOL CDMDManager::LoadDMDBuffer(char *chFullFileName, COleVariant *pFrameBuffer)
{
	CString strTemp;
	CString strFileName;

	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;		

	if( m_bConnected == FALSE )
	{
		return FALSE;
	}

	if( CheckAvailableFile(chFullFileName) == FALSE )
	{
		return FALSE;
	}	

#ifdef DMD_EXIST
	if( !pWnd->m_cDC1100.LoadImageFileToBuffer(chFullFileName, pFrameBuffer, 0) )
	{
		strFileName.Format("%s", chFullFileName);
		strTemp = "Error in Load Image File to Buffer! : ";
		strTemp += strFileName;
		AfxMessageBox(strTemp);
		return FALSE;
	}
#endif

	return TRUE;
}

BOOL CDMDManager::LoadDMDBuffer(CString strFullFileName, COleVariant *pFrameBuffer)
{
	CString strTemp;
	char *chTemp;
	BOOL bReturn;
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	
	chTemp = strFullFileName.GetBuffer(strTemp.GetLength());
	
	bReturn = LoadDMDBuffer(chTemp, pFrameBuffer);
	
	strFullFileName.ReleaseBuffer();

	return bReturn;
}

BOOL CDMDManager::DisplayFromBuffer(COleVariant *pFrameBuffer)
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;

	if( m_bConnected == FALSE )
	{
		return FALSE;
	}

	if( pFrameBuffer == NULL )
	{
		return FALSE;
	}

#ifdef DMD_EXIST	
	pWnd->m_cDC1100.LoadFrameBuffer(pFrameBuffer);
	pWnd->m_cDC1100.LoadResetFrame();
#endif
	
	return TRUE;
}


BOOL CDMDManager::AddMask(CString strMaskFullName)
{
	int len;

	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	MaskBuffer *pMaskBuffer;

	if( GetCurrentMaskBuffer(strMaskFullName) == NULL )
	{
	//	pMaskBuffer = new MaskBuffer;
		if( m_bFullMaskBuffer == TRUE )
		{
			return FALSE;
		}
		pMaskBuffer = &m_MaskBufferArray[m_iMaskBufferIndex];
		/*	
		pMaskBuffer->pByteArray = new CByteArray;
		pMaskBuffer->pByteArray->SetSize (1024 * 768 / 8);		
		pMaskBuffer->pFrameBuffer = new COleVariant(*(pMaskBuffer->pByteArray));
		*/
		len = strMaskFullName.GetLength();
		pMaskBuffer->chFullFileName = new char[len+1];
		strcpy(pMaskBuffer->chFullFileName, strMaskFullName);	
		pMaskBuffer->chFullFileName[len] = '\0';
				
		if( LoadDMDBuffer(pMaskBuffer->chFullFileName, pMaskBuffer->pFrameBuffer) == FALSE )
		{
			DeleteMaskBuffer(pMaskBuffer);
			m_iMaskBufferIndex--;
			if( m_iMaskBufferIndex < 0 )
			{
				m_iMaskBufferIndex = 0;
			}
			return FALSE;
		}
		m_iMaskBufferIndex++;
		if( m_iMaskBufferIndex >= MAX_NUM_OF_MASK_BUFFER )
		{
			m_bFullMaskBuffer = TRUE;
		}

		AddMaskBufferToList(pMaskBuffer);
	}

	return TRUE;
}

void CDMDManager::DeleteMaskBuffer(MaskBuffer *pMaskBuffer)
{
	delete pMaskBuffer->chFullFileName;
	pMaskBuffer->chFullFileName = NULL;
//	delete pMaskBuffer->pByteArray;
//	pMaskBuffer->pByteArray = NULL;
//	delete pMaskBuffer;
}

void CDMDManager::AddMaskBufferToList(MaskBuffer *pMaskBuffer)
{
	m_BufferList.AddTail((CObject *)pMaskBuffer);
}

BOOL CDMDManager::ReloadDMDBuffer(CString strFullName)
{
	MaskBuffer *pMaskBuffer;
	int len;

	if( (pMaskBuffer = GetCurrentMaskBuffer(strFullName)) == NULL )
	{
		return FALSE;
	}
	
	len = strFullName.GetLength();
	pMaskBuffer->chFullFileName = new char[len+1];
	strcpy(pMaskBuffer->chFullFileName, strFullName);	
	pMaskBuffer->chFullFileName[len] = '\0';
				
	if( LoadDMDBuffer(pMaskBuffer->chFullFileName, pMaskBuffer->pFrameBuffer) == FALSE )
	{
		DeleteMaskBuffer(pMaskBuffer);
		return FALSE;
	}

	return TRUE;
}


void CDMDManager::TimerRun()
{
	
}

//=======================================================================================

void CDMDManager::SetMMTimer(int iEvent, int iTime)
{
	m_iTimerEvent = iEvent;
	m_nTimerID = ::timeSetEvent(iTime, DEFAULT_MMTIMER_RESOLUTION_DMD, 
									(LPTIMECALLBACK) MMTimerDMD,
									(DWORD) this, TIME_PERIODIC | TIME_CALLBACK_FUNCTION);
}


//======= Multimedia Timer: Callback Function ================================
void CALLBACK MMTimerDMD( UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	CDMDManager* pClass = (CDMDManager*) dwUser;
    //pClass ̿ ó
	
	pClass->TimerRun();

	::timeKillEvent(uID);
	if( pClass->m_bStartAction == TRUE )
	{
		pClass->SetMMTimer(0, pClass->m_iNextTimerPeriod);
	}
}

//============================================================================

MaskBuffer *CDMDManager::GetCurrentMaskBuffer(CString strFullName)
{
	/*
	POSITION pos;
	MaskBuffer *pMaskBuffer;
	CString strName;
	
	for(pos = m_BufferList.GetHeadPosition();pos != NULL; )
	{
		pMaskBuffer = (MaskBuffer *)m_BufferList.GetNext(pos);
		strName.Format("%s", pMaskBuffer->chFullFileName);
		if( strName == strFullName )
		{
			return pMaskBuffer;
		}
	}
	*/
	int i;
	CString strName;
	for(i=0;i<MAX_NUM_OF_MASK_BUFFER;i++)
	{
		if(m_MaskBufferArray[i].chFullFileName != NULL )
		{
			strName.Format("%s", m_MaskBufferArray[i].chFullFileName);
		}

		if( strFullName == strName )
		{
			return &m_MaskBufferArray[i];
		}
	}

	return NULL;
}


BOOL CDMDManager::GetValidMaskBuffer(CString strFullName)
{
	m_pCurrentMaskBuffer = GetCurrentMaskBuffer(strFullName);

	if( m_pCurrentMaskBuffer == NULL )
	{
		return FALSE;
	}

	return TRUE;		
}

BOOL CDMDManager::DisplayOnDMD()
{
	return DisplayFromBuffer(m_pCurrentMaskBuffer->pFrameBuffer);
}

BOOL CDMDManager::DisplayOnDMD(CString strFullName)
{
	MaskBuffer *pMaskBuffer;

	pMaskBuffer = GetCurrentMaskBuffer(strFullName);
	
	if( pMaskBuffer == NULL )
	{
		return FALSE;
	}	

	return DisplayFromBuffer(pMaskBuffer->pFrameBuffer);
}
