// PressControl.cpp : implementation file
//

#include "stdafx.h"
#include "BIOD_Lite.h"
#include "PressControl.h"
#include "BIOD_LiteDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPressControl

CPressControl::CPressControl()
{
}

CPressControl::~CPressControl()
{
}


BEGIN_MESSAGE_MAP(CPressControl, CWnd)
	//{{AFX_MSG_MAP(CPressControl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPressControl message handlers

void CPressControl::Init(CWnd *pWnd)
{
 	m_pParentWnd = pWnd;
 	m_strCommRecv = "";
 
 	m_fMaxPressure = MAX_PRESSURE;
 	m_fDesiredPressure = 2.0;
 	
 	CString strTemp;
 	PARENT_CLASS *pClass = (PARENT_CLASS *)m_pParentWnd;
 
 	strTemp.Format("%.2f", m_fDesiredPressure);
 	pClass->SetDlgItemText(IDC_EDIT_PRESS_OUTPUT, strTemp);
	pClass->SetDlgItemText(IDC_EDIT_PRESS_DESIRED, strTemp);
 	pClass->SetDlgItemText(IDC_EDIT_PRESS_VAR_STEP, "0.2");
 
	m_strDeviceID = DEFAULT_DEVICE_ID_PRESS;
 
 	SetMMTimer(TIMER_EVENT_QUERY_PRESS_STATUS, 800);
}

void CPressControl::Init(CWnd *pWnd, CgtComPort *pComPort)
{	
	m_pParentWnd = pWnd;
	m_pComPort = pComPort;

 	m_strCommRecv = "";
 
 	m_fMaxPressure = MAX_PRESSURE;
 	m_fDesiredPressure = 2.0;
 	
 	CString strTemp;
 	PARENT_CLASS *pClass = (PARENT_CLASS *)m_pParentWnd;
 
 	strTemp.Format("%.2f", m_fDesiredPressure);
 	pClass->SetDlgItemText(IDC_EDIT_PRESS_OUTPUT, strTemp);
	pClass->SetDlgItemText(IDC_EDIT_PRESS_DESIRED, strTemp);
 	pClass->SetDlgItemText(IDC_EDIT_PRESS_VAR_STEP, "0.2");
 
	m_strDeviceID = DEFAULT_DEVICE_ID_PRESS;

//	InitCOMPort();
 
 	SetMMTimer(TIMER_EVENT_QUERY_PRESS_STATUS, 800);
}


void CPressControl::CommSend(CString str)
{	
	str += 0x0d;	//'\r'
	m_pComPort->sendString(str);
}


void CPressControl::ReceiveData()
{
	CString strReceive;
	int iReceiveLen, i;
	
	m_pComPort->receiveString( strReceive );
	iReceiveLen = strReceive.GetLength();

	for(i=0;i<iReceiveLen;i++)
	{
		if( (strReceive.GetAt(i) == '\r') || (strReceive.GetAt(i) == '\n') )
		{			
			if(  m_strPrintRecv.GetLength() > 1024 )
			{
				m_strPrintRecv.Empty();				
			}
			m_strPrintRecv += m_strCommRecv;
			
			ParseData(m_strCommRecv);
			m_strCommRecv = "";
		}
		else
		{			
			m_strCommRecv += strReceive.GetAt(i);
		}
	}
}


void CPressControl::ParseData(CString strRecv)
{
	char *chFile;
	char seps[] = " +-\r\n";
	char *token;

	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;

	CString strTemp;	
	int iIndex;
	
	chFile = strRecv.GetBuffer(strRecv.GetLength());
	iIndex = 0;
	token = strtok(chFile, seps);

	while(token != NULL )
	{
		strTemp.Format("%s", token);
		token = strtok(NULL, seps);
		iIndex++;

		switch( iIndex )
		{
		case 1:
			
			break;
		case 2:
			pWnd->SetDlgItemText(IDC_EDIT_PRESS_INPUT, strTemp);
			break;
		case 3:
			pWnd->SetDlgItemText(IDC_EDIT_PRESS_OUTPUT, strTemp);
			break;
		default:
			break;
		}
	}
	strRecv.ReleaseBuffer();
}


void CPressControl::PressControl(BOOL bUpDown)
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	
	CString strTemp, strDesired, strDeviceID, strDelta;
	char *chTemp;
	int iSendValue;
	double fDelta;
	
	pWnd->GetDlgItemText(IDC_EDIT_PRESS_OUTPUT, strDesired);	
	chTemp = strDesired.GetBuffer(strDesired.GetLength());
	m_fDesiredPressure = atof(chTemp);
	strDesired.ReleaseBuffer();

	pWnd->GetDlgItemText(IDC_EDIT_PRESS_VAR_STEP, strDelta);	
	chTemp = strDelta.GetBuffer(strDelta.GetLength());
	fDelta = atof(chTemp);
	strDelta.ReleaseBuffer();

	if( bUpDown == TRUE )	//UP
	{
		m_fDesiredPressure += fDelta;
		if( m_fDesiredPressure > m_fMaxPressure )
		{
			m_fDesiredPressure = m_fMaxPressure;
		}
	}
	else	//Down
	{
		m_fDesiredPressure -= fDelta;
		if( m_fDesiredPressure < 0 )
		{
			m_fDesiredPressure = 0;
		}
	}

	iSendValue = (int)(m_fDesiredPressure*64000/m_fMaxPressure);
	strTemp.Format("%d", iSendValue);
	strDeviceID = m_strDeviceID;
	strDeviceID += strTemp;
	CommSend(strDeviceID);

	strDesired.Format("%.2f", m_fDesiredPressure);
	pWnd->SetDlgItemText(IDC_EDIT_PRESS_OUTPUT, strDesired);

	(pWnd->GetDlgItem(IDC_BUTTON_UV_SHUTTERTIME_READ))->SetFocus();
	
}

void CPressControl::Status()
{
	CommSend('a');
}


void CPressControl::Set()
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;

	CString strDesired, strTemp;
	char *chTemp;
	int iSendValue;

	pWnd->GetDlgItemText(IDC_EDIT_PRESS_DESIRED, strDesired);
	chTemp = strDesired.GetBuffer(strDesired.GetLength());
	
	m_fDesiredPressure = atof(chTemp);
	strDesired.ReleaseBuffer();

	iSendValue = (int)(m_fDesiredPressure*64000/m_fMaxPressure);
	strDesired.Format("%d", iSendValue);
	strTemp = m_strDeviceID + strDesired;

	CommSend(strTemp);

}



void CPressControl::SetMMTimer(int iEvent, int iTime)
{
	m_iTimerEvent = iEvent;
	m_nTimerID = ::timeSetEvent(iTime, DEFAULT_MMTIMER_RESOLUTION_PRESS, 
									(LPTIMECALLBACK) MMPressTimerProcess,
									(DWORD) this, TIME_PERIODIC | TIME_CALLBACK_FUNCTION);
}


//======= Multimedia Timer of UV: Callback Function ================================
void CALLBACK MMPressTimerProcess( UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	CPressControl* pClass = (CPressControl*) dwUser;
    //pClass ̿ ó

	switch(pClass->m_iTimerEvent)
	{
	case TIMER_EVENT_QUERY_PRESS_STATUS:
		{
			::timeKillEvent(pClass->m_nTimerID);
			pClass->Status();
		}		
		break;
	default:
		break;
	}
	
}

void CPressControl::PressControl(CString strDesiredPressure)
{
	char *chTemp;
	CString strTemp, strSend;
	int iSendValue;

	chTemp = strDesiredPressure.GetBuffer(strDesiredPressure.GetLength());
	m_fDesiredPressure = atof(chTemp);
	strTemp.ReleaseBuffer();

	iSendValue = (int)(m_fDesiredPressure*64000/m_fMaxPressure);
	strTemp.Format("%d", iSendValue);
	
	strSend = m_strDeviceID;
	strSend += strTemp;
	CommSend(strSend);

}


void CPressControl::SetComPortInfo(CComPortUI *pComPortUI)
{
	pComPortUI->m_iBaudrate = 19200;
	pComPortUI->m_iComPort = DEFAULT_PRESS_COMPORT;
	CString strComPort;
	strComPort.Format("COM%d", pComPortUI->m_iComPort);
	pComPortUI->m_strComPort = strComPort;
}
