// ValveControl.cpp : implementation file
//

#include "stdafx.h"
#include "BIOD_Lite.h"
#include "BIOD_LiteDlg.h"
#include "ValveControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CValveControl

CValveControl::CValveControl()
{
	
}

CValveControl::~CValveControl()
{
	for(int i=0;i<NUM_OF_VALVE_PORT;i++)
	{
		DAQmxStopTask(m_TaskOut[i]);
		DAQmxClearTask(m_TaskOut[i]);
	}
}


BEGIN_MESSAGE_MAP(CValveControl, CWnd)
	//{{AFX_MSG_MAP(CValveControl)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CValveControl message handlers

void CValveControl::SetParentWnd(CWnd *pWnd)
{
	m_pParentWnd = pWnd;
}

void CValveControl::Init(CWnd *pWnd)
{
	m_pParentWnd = pWnd;
	Init();
}

void CValveControl::Init()
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	
	InitDAQmx();

	CButton *pButton;
	int i, j, k;
	for(i=0;i<NUM_OF_VALVE_PORT;i++)
	{
		for(j=0;j<NUM_OF_VALVE_LINE;j++)
		{
			m_iValveStatus[i][j] = VALVE_STAT_OFF;
			pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[i][j]));
			pButton->SetWindowText("F");
		}
	}

	for(i=0;i<NUM_OF_VALVE_PLAN;i++)
	{
		for(j=0;j<NUM_OF_VALVE_PORT;j++)
		{
			for(k=0;k<NUM_OF_VALVE_LINE;k++)
			{
				m_iValveRunPlan[i][j][k] = VALVE_STAT_DISEL;
			}			
		}
	}
}

void CValveControl::InitDAQmx()
{
	int i, j, len;
	CString strTemp, strTemp2;
	char *chTemp;

	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;

	m_bData = FALSE;
	m_bTaskStart = FALSE;
	strTemp = DEFAULT_DEVICE_ID;
	strTemp += "/port0";
	len = strTemp.GetLength();
	chTemp = strTemp.GetBuffer(len);
	for(i=0;i<NUM_OF_VALVE_PORT;i++)
	{
		DAQmxCreateTask("", &m_TaskOut[i]);
		strTemp2.Format("%d", i);
		strTemp.SetAt(len-1, strTemp2.GetAt(0));
		
		DAQmxCreateDOChan(m_TaskOut[i], chTemp,"",DAQmx_Val_ChanForAllLines);
		DAQmxStartTask(m_TaskOut[i]);		
	}

	for(i=0;i<NUM_OF_VALVE_PORT;i++)
	{
		for(j=0;j<NUM_OF_VALVE_LINE;j++)
		{
			m_data[i][j] = 0;
		}
	}
	
	m_strDAQName = DEFAULT_DEVICE_ID;
	pWnd->SetDlgItemText(IDC_EDIT_NIDAQ_DEVICE_ID, m_strDAQName);
	m_bTaskStart = TRUE;

	pWnd->m_cComboValveAction.SetCurSel(0);

}


void CValveControl::NIDAQRun(CString strDeviceID)
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	m_strDAQName = strDeviceID;

	int i, j, len;
	CString strTemp, strTemp2;
	char *chTemp;

	if( m_bTaskStart == TRUE )
	{
		for(i=0;i<NUM_OF_VALVE_PORT;i++)
		{
			DAQmxClearTask(m_TaskOut[i]);
		}

		m_bData = FALSE;
		m_bTaskStart = FALSE;
		strTemp = m_strDAQName;
		strTemp += "/port0";
		len = strTemp.GetLength();
		chTemp = strTemp.GetBuffer(len);
		for(i=0;i<NUM_OF_VALVE_PORT;i++)
		{
			DAQmxCreateTask("", &m_TaskOut[i]);
			strTemp2.Format("%d", i);
			strTemp.SetAt(len-1, strTemp2.GetAt(0));
			
			DAQmxCreateDOChan(m_TaskOut[i], chTemp,"",DAQmx_Val_ChanForAllLines);
			DAQmxStartTask(m_TaskOut[i]);		
		}

		for(i=0;i<NUM_OF_VALVE_PORT;i++)
		{
			for(j=0;j<NUM_OF_VALVE_LINE;j++)
			{
				m_data[i][j] = 0;
			}
		}
		pWnd->SetDlgItemText(IDC_EDIT_NIDAQ_DEVICE_ID, m_strDAQName);
		m_bTaskStart = TRUE;

		pWnd->m_cComboValveAction.SetCurSel(0);
	}

}

void CValveControl::ValveControl(int iPort)
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	CButton *pButton;

	int iLine = 0;

	if( m_iValveStatus[iPort][iLine] == VALVE_STAT_OFF )
	{
		for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
		{
			m_data[iPort][iLine] = 1;
			pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[iPort][iLine]));
			pButton->SetWindowText("O");
			m_iValveStatus[iPort][iLine] = VALVE_STAT_ON;				
		}
		
		DAQmxWriteDigitalLines(m_TaskOut[iPort], 1, 1, 10.0, DAQmx_Val_GroupByChannel, m_data[iPort], NULL, NULL);
	}
	else
	{
		for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
		{
			m_data[iPort][iLine] = 0;
			pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[iPort][iLine]));
			pButton->SetWindowText("F");
			m_iValveStatus[iPort][iLine] = VALVE_STAT_OFF;				
		}
	
		DAQmxWriteDigitalLines(m_TaskOut[iPort], 1, 1, 10.0, DAQmx_Val_GroupByChannel, m_data[iPort], NULL, NULL);
	}
}


void CValveControl::ValveControl(int iPort, int iLine)
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	CButton *pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[iPort][iLine]));

	if( m_iValveStatus[iPort][iLine] == VALVE_STAT_OFF )
	{
		m_data[iPort][iLine] = 1;

		m_iValveStatus[iPort][iLine] = VALVE_STAT_ON;
		pButton->SetWindowText("O");
	}
	else
	{
		m_data[iPort][iLine] = 0;		

		m_iValveStatus[iPort][iLine] = VALVE_STAT_OFF;
		pButton->SetWindowText("F");
	}
	DAQmxWriteDigitalLines(m_TaskOut[iPort], 1, 1, 10.0, DAQmx_Val_GroupByChannel, m_data[iPort], NULL, NULL);
}


void CValveControl::ValveControl(int iPort, int iLine, int iOnOff)
{
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;
	CButton *pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[iPort][iLine]));

	m_iValveStatus[iPort][iLine] = iOnOff;
	if( iOnOff == VALVE_STAT_OFF )
	{
		pButton->SetWindowText("F");

		m_data[iPort][iLine] = 0;
		m_iValveStatus[iPort][iLine] = VALVE_STAT_OFF;
	}
	else if( iOnOff == VALVE_STAT_ON )
	{
		pButton->SetWindowText("O");

		m_data[iPort][iLine] = 1;		
		m_iValveStatus[iPort][iLine] = VALVE_STAT_ON;
	}
		
	DAQmxWriteDigitalLines(m_TaskOut[iPort], 1, 1, 10.0, DAQmx_Val_GroupByChannel, m_data[iPort], NULL, NULL);
}


void CValveControl::SetAction(int iIndex)
{
	int iPort, iLine;
	pDlgValveSet = new CValveSet();

	if( pDlgValveSet->DoModal() == IDOK )
	{
		for(iPort=0;iPort<NUM_OF_VALVE_PORT;iPort++)
		{
			for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
			{
				m_iValveRunPlan[iIndex][iPort][iLine] = pDlgValveSet->m_iValveStatus[iPort][iLine];
			}
		}	
	}

	delete pDlgValveSet;
}

void CValveControl::RunAction(int iIndex)
{
	int iPort, iLine;

	for(iPort=0;iPort<NUM_OF_VALVE_PORT;iPort++)
	{
		for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
		{
			if(m_iValveRunPlan[iIndex][iPort][iLine] != VALVE_STAT_DISEL)
			{
				if(m_iValveRunPlan[iIndex][iPort][iLine] == VALVE_STAT_OFF)
				{
					m_iValveRunPlan[iIndex][iPort][iLine] = VALVE_STAT_ON;
				}
				else
				{
					m_iValveRunPlan[iIndex][iPort][iLine] = VALVE_STAT_OFF;
				}
				ValveControl(iPort, iLine, m_iValveRunPlan[iIndex][iPort][iLine]);
			}
		}
	}
}

void CValveControl::GetValveString(CString &strValve)
{	
	int iPort, iLine;
	BOOL bAllOff, bAllOn;
	bAllOff = bAllOn = TRUE;

	for(iPort=0;iPort<NUM_OF_VALVE_PORT;iPort++)
	{
		strValve += "[";
		for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
		{
			if( m_iValveStatus[iPort][iLine] == VALVE_STAT_OFF )
			{
				strValve += "0";
				bAllOn = FALSE;
			}
			else
			{
				strValve += "1";
				bAllOff = FALSE;
			}
		}
		strValve += "]";
	}

	if( bAllOff == TRUE )
	{
		strValve = "all off";
	}
	else if( bAllOn == TRUE )
	{
		strValve = "all on";
	}
}

void CValveControl::ValveControl(CString strValveString)
{		
	int iPort, iLine, iLen, iDiff, i;
	char seps[] = "[]";
	char *token, *chValveString;
	CString strTemp; 
	
	PARENT_CLASS *pWnd = (PARENT_CLASS *)m_pParentWnd;	
	CButton *pButton;
	

	if( (strValveString == "all off") || (strValveString == "ALL OFF") )
	{
		for(iPort=0;iPort<NUM_OF_VALVE_PORT;iPort++)
		{
			for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
			{
				m_data[iPort][iLine] = 0;
				pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[iPort][iLine]));
				pButton->SetWindowText("F");
				m_iValveStatus[iPort][iLine] = VALVE_STAT_OFF;
			}
			
			DAQmxWriteDigitalLines(m_TaskOut[iPort], 1, 1, 10.0, DAQmx_Val_GroupByChannel, m_data[iPort], NULL, NULL);
		}		
	}
	else if( (strValveString == "all on") || (strValveString == "ALL ON") )
	{
		for(iPort=0;iPort<NUM_OF_VALVE_PORT;iPort++)
		{
			for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
			{
				m_data[iPort][iLine] = 1;
				pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[iPort][iLine]));
				pButton->SetWindowText("O");
				m_iValveStatus[iPort][iLine] = VALVE_STAT_ON;
			}
			
			DAQmxWriteDigitalLines(m_TaskOut[iPort], 1, 1, 10.0, DAQmx_Val_GroupByChannel, m_data[iPort], NULL, NULL);
		}		
	}
	else
	{
		chValveString = strValveString.GetBuffer(strValveString.GetLength());
		token = strtok(chValveString, seps);
		
		iPort = 0;
		iLine = 0;
		while(token != NULL )
		{
			strTemp.Format("%s", token);
			token = strtok(NULL, seps);

			iLen = strTemp.GetLength();
			if( iLen != NUM_OF_VALVE_LINE)
			{				
				if( iLen < NUM_OF_VALVE_LINE )
				{
					iDiff = NUM_OF_VALVE_LINE - iLen;
					for(i=0;i<iDiff;i++)
					{
						strTemp += "0";
					}
				}
				else
				{
					iDiff = iLen - NUM_OF_VALVE_LINE;
					strTemp.Left(NUM_OF_VALVE_LINE);
				}
			}

			for(iLine=0;iLine<NUM_OF_VALVE_LINE;iLine++)
			{
				pButton = (CButton *)(pWnd->GetDlgItem(pWnd->m_idValveMatrix[iPort][iLine]));
				if( strTemp.GetAt(iLine) == '1' )
				{
				//	ValveControl(iPort, iLine, VALVE_STAT_ON);
					m_data[iPort][iLine] = 1;				
					pButton->SetWindowText("O");
					m_iValveStatus[iPort][iLine] = VALVE_STAT_ON;
				}
				else
				{
				//	ValveControl(iPort, iLine, VALVE_STAT_OFF);
					m_data[iPort][iLine] = 0;
					pButton->SetWindowText("F");
					m_iValveStatus[iPort][iLine] = VALVE_STAT_OFF;
				}				
			}
			DAQmxWriteDigitalLines(m_TaskOut[iPort], 1, 1, 10.0, DAQmx_Val_GroupByChannel, m_data[iPort], NULL, NULL);

			iPort++;
			if(iPort >= NUM_OF_VALVE_PORT)
			{
				break;
			}
		}
	}
	strValveString.ReleaseBuffer();
}

